<%@ LANGUAGE="JSCRIPT" %><%

// Contemplate Assembler (assembler.asp) version 1.2.2
// Copyright 1999-2007 Type A Learning Agency (http://www.typea.net)
// This file may be used, modified, or redistributed under the terms
// of the open-source agreement contained in docs/license.txt


	Server.ScriptTimeout = 60; // this is a big help for debugging because IIS doesn't stop processing when you click stop in the browser
	
// this is a special JScript workaround for testing if an argument is set or not

	$undefined = Request.QueryString("alkdjfalkdjajdslkfjdalsjfdajljf");
	

// if the script is being used by the flattener or formulator, we'll give a different kind of output

	$skip_rendering = (Request.QueryString("skip_rendering") != $undefined) ? String(Request.QueryString("skip_rendering")) : "" ;
	$formulator_fill = (Request.QueryString("formulator_fill") != $undefined) ? String(Request.QueryString("formulator_fill")) : "" ;
	
	
// set visible text here for easier localization

	$search_label_success = "Search results for";
	$search_label_failure = "Can't find";
	$search_label_none = "Please enter a search string";
	
	
// initialize variables that we might use before setting

	$error_log = "";
	$show_errors = "";
	$output = "";
	$output_two = "";
	$pre_render_files = 0;
	$read_page_definitions_from = "";
	$page_definitions = "";
	$offset = 0;
	$embed_variable_keys = new Array();
	$embed_variable_values = new Array();
	$embeds = new Array();
	$tag_names = new Array();
	$tag_names_flattened = "";
	$file_fields = "";
	$stored_selections = "";
	$latest_mod_date = 0;	
	$latest_mod_date_formatted = "";
	$visitor_ID = "";
	$template = "";
	$page_definition = "";
	$settings_used = "";
	$header = "";


// define some useful functions

	function get_file($file, $method, $check_last_modified) { // method can be "http", "filesystem", or "auto" (auto looks at $pre_render_files list)
		$text = "";
		$re11 = new RegExp("\/(\\.\\w.*)", "");
		$re12 = new RegExp("([^\\w-\.\/\?\&\=\%])", "");
		if ($re11.test($file)) { // don't read files whose names start with "."
			$text = show_error("Not authorized to read hidden file named \"" + RegExp.$1 + "\"");
			$file_missing = 1;
		} else if ($re12.test($file)) { // don't read files whose names contain characters that could be used to read remote files, or to hack into the open command (Perl only)
			$text = show_error("File names can't contain the character " + RegExp.$1); // is there a way to return the whole matched expression, and remove the parentheses around the expression?
			$file_missing = 1;
		} else {
		
			// first, figure out if we're going to read over HTTP or through the filesystem...
			if (($method == "")||($method == "auto")) {
				if ($pre_render_files) {
					for ($n=0; $n < $pre_render_files.length; $n++) {
						if ($file.indexOf($pre_render_files[$n]) != -1) { $method = "http"; }
					}
				}
			}

			// ...then get the file
			if ($method == "http") {

				// 1) prepare the URL for this type of connection
				$file_URL = absolute_path($file, "http");

				// 2) open a connection to the file
				XHO = Server.CreateObject("Microsoft.XMLHTTP");
				XHO.Open("GET", $file_URL, 0);
				$file_exists = 1; // to do: how can we test for this?
				if (! $file_exists) {
					$text = show_error("Can't open the file named \"" + $file + "\"" + $check_URL);
					$file_missing = 1;
				} else {
					XHO.Send();
					
					// 3) read the file
					$text = XHO.responseText;
	
					// 4) close the file connection
					XHO = "";

					$file_missing = 0;
				}

				//$output += "<p>reading " + $file_URL + " over http<p>";  // debug

			} else {

				// 1) prepare the URL for this type of connection
				$file_URL = absolute_path($file, "filesystem");

				// 2) open a connection to the file
				FSO = Server.CreateObject("Scripting.FileSystemObject");
				$file_exists = FSO.FileExists($file_URL);
				if (! $file_exists) {
					$text = show_error("Can't open the file named \"" + $file + "\"" + $check_URL);
					$file_missing = 1;
				} else {
				
					// 3) read the file
					$myfile = FSO.OpenTextFile($file_URL, 1);
					$text = $myfile.ReadAll();
					$file_missing = 0;
	
					// 4) for local files, catch the file's modification date (for $read_page_definitions_from and $template, plus content files when the template contains a env_last_modified tag)
					if ($check_last_modified) {
						$myfile2 = FSO.getFile($file_URL);
						$ASP_date = $myfile2.dateLastModified;
						$JScript_date = new Date($ASP_date);
						$mtime = $JScript_date.getTime();
						if ($mtime > $latest_mod_date) {
							$latest_mod_date = $mtime;
							$year = $JScript_date.getFullYear();
							$month = $JScript_date.getMonth() + 1; if ($month < 10) { $month = "0" + String($month); }
							$day = $JScript_date.getDate(); if ($day < 10) { $day = "0" + String($day); }
							$hour = $JScript_date.getHours();
							if ($hour < 12) {
								$ampm = "am";
							} else {
								$ampm = "pm";
								if ($hour > 12) {
									$hour = $hour - 12;
								}
							}
							//if ($hour < 10) { $hour = "0" + String($hour); }
							$minute = $JScript_date.getMinutes(); if ($minute < 10) { $minute = "0" + String($minute); }
							$latest_mod_date_formatted = $year + "-" + $month + "-" + $day + " - " + $hour + ":" + $minute + " " + $ampm;
						}
					}
			
					// 5a) close the file connection
					$myfile.Close();
					
				}

				// 5b) close the file connection
				FSO = "";

				//$output += "<p>reading " + $file_URL + " through filesystem<p>"; // debug
				
			}
							
			// finally, conform all line breaks to avoid cross-platform issues
			// we'd rather conform to Unix line breaks (\n), but that doesn't work in ASP, which doesn't support the s flag in regular expressions
			$text = $text.replace(/\r\n/g, "\r"); // change DOS to Mac
			$text = $text.replace(/\n/g, "\r"); // change Unix to Mac
			
		}
		return $text;
	}
	
	function get_field($source_text, $field_name, $file_type) {
		if (typeof($field_name) == "undefined") { $field_name = ""; }
		if ($file_type.toLowerCase().indexOf("xml") != -1) {
			
			$source_text = make_XML_paths($source_text);
			$tag_type = "content";
			$re = new RegExp('<' + $tag_type + '[^>]+name=[\"\']?' + regex_quote($field_name) + '\\b[^>]*>(.*?)<\/' + $tag_type + '>', 'i'); // we'd like to use the s flag here, if it existed in ASP
			if ($re.test($source_text)) {
				$field_text = RegExp.$1;
			} else {
				$field_text = show_error("Can't find the " + $tag_type + " tag named \"" + $field_name + "\" in " + $content_file + $check_URL);
			}

		} else {		

			if ($field_name.indexOf($field_marker) == -1) {  // but what if formatting gets between the marker and the label?
				$field_name = $field_marker + $field_name;  // in that case, remove these lines and change $content_field to $field_marker.*$content_field below
			}
			$re = new RegExp($field_name + '(\\W.*\/td>.*<td[^>]*>.*<\/td>)', 'i'); // we'd like to use the s flag here, if it existed in ASP
			if ($re.test($source_text)) {
				$field_text = RegExp.$1;  // do a rough trim
				$field_text = $field_text.replace(/<\/td>/i, "");  // remove up to the previous </td>
				$field_text = $field_text.replace(/<td[^>]*>/i, "split-here-hey");  // mark the opening <td> // we'd like to use the s flag here, if it existed in ASP
				$re = new RegExp(regex_quote($field_marker), 'i');
				$field_text = $field_text.replace($re, "split-here-hey");  // mark the next field marker
				$temp = $field_text.split("split-here-hey");  // trim at the markers
				$field_text = $temp[1];
				$re = new RegExp("(.*)<\/td>", "i"); // remove from the trailing </td> // we'd like to use the s flag here, if it existed in ASP
				if ($re.test($field_text)) {
					$field_text = RegExp.$1;
				}
			} else {
				if (! $file_missing) {
					$field_text = show_error("Can't find the field named \"" + $field_name + "\" in " + $content_file + $check_URL + $check_field_label);
				}
			}

		}
		return $field_text;
	}
	
	function get_form($source_text, $form_element) {
		$value = "";

		// this function doesn't recognize values like this: <input name = foo> we could make it do so by adding /s* around all the equals signs, but it doesn't now

		// we can't set these options up as else ifs like in the other languages because JScript requires multiple lines of code to put a variable in a regexp
		
		// before looking for the value, let's find out if it has single or double quotes around it or not
		$re = new RegExp('name=[\"\']?' + $form_element + '\\W[^>]*value=[^\"\']', 'i'); // we'd like to use the s flag here, if it existed in ASP
		if ($re.test($source_text)) {
			$value_match = "([^ >]*)";
		} else {
			// the previous regexp covers all other input types, but the select menu is different because the type and value are in different tags (we wouldn't need this if we could write a regex that spanned the <select> and <option> tags, but that wasn't too greedy with other input types)
			$re = new RegExp('name=[\"\']?' + $form_element + '\\W[^>]*>.*?<option[^>]+value=[^\"\']', 'i'); // we'd like to use the s flag here, if it existed in ASP
			if ($source_text.search($re) != -1) {
				$value_match = "([^ >]*)";
			} else {
				$re = new RegExp('name=[\"\']?' + $form_element + '\\W[^>]*value=\'', 'i'); // we'd like to use the s flag here, if it existed in ASP
				if ($source_text.search($re) != -1) {
					$value_match = "'([^\']*?)'";
				} else {
					// the previous regexp covers all other input types, but the select menu is different because the type and value are in different tags (we wouldn't need this if we could write a regex that spanned the <select> and <option> tags, but that wasn't too greedy with other input types)
					$re = new RegExp('name=[\"\']?' + $form_element + '\\W[^>]*>.*?<option[^>]+value=\'', 'i'); // we'd like to use the s flag here, if it existed in ASP
					if ($source_text.search($re) != -1) {
						$value_match = "'([^\']*?)'";
					} else {
						// we'll let the double quote be the default, so if something goes wrong we still might get the desired result
						$value_match = "\"([^\"]*?)\""; 
					}
				}
			}
		}

		// okay, now let's look for it
		$re = new RegExp('<input[^>]+name=[\"\']?' + $form_element + '\\W[^>]*type=[\"\']?text[\"\']?[^>]+value=' + $value_match + '[^>]*>', 'i'); // we'd like to use the s flag here, if it existed in ASP
		if ($re.test($source_text)) {
			$value = RegExp.$1;
		} else {
			$re = new RegExp('<input[^>]+name=[\"\']?' + $form_element + '\\W[^>]*type=[\"\']?radio[\"\']?[^>]+value=' + $value_match + '[^>]+checked[^>]*>', 'i'); // we'd like to use the s flag here, if it existed in ASP
			if ($re.test($source_text)) {
				$value = RegExp.$1;
			} else {
				$re = new RegExp('<input[^>]+name=[\"\']?' + $form_element + '\\W[^>]*type=[\"\']?checkbox[\"\']?[^>]+value=' + $value_match + '[^>]+checked[^>]*>', 'i'); // we'd like to use the s flag here, if it existed in ASP
				if ($re.test($source_text)) {
					// return a list (not array) of all the checked boxes
					while ($re.test($source_text)) {
						$value += RegExp.$1 + ", ";
						$source_text = $source_text.replace($re, '');
					}
					$value = $value.substr(0, ($value.length-2));
				} else {
					$re = new RegExp('<select[^>]+name=[\"\']?' + $form_element + '\\W[^>]*>.*?<option[^>]+value=' + $value_match + '[^>]+selected[^>]*>.*?<\/select>', 'i'); // we'd like to use the s flag here, if it existed in ASP
					if ($re.test($source_text)) {
						$value = RegExp.$1;
					} else {
						$re = new RegExp('<textarea[^>]+name=[\"\']?' + $form_element + '\\W[^>]*>(.*?)<\/textarea>', 'i'); // we'd like to use the s flag here, if it existed in ASP
						if ($re.test($source_text)) {
							$value = RegExp.$1;
						} else {
							$re = new RegExp('name=[\"\']?' + $form_element + '\W', 'i'); // we'd like to use the s flag here, if it existed in ASP
							if ($re.test($source_text)) {
								// some HTML editors might remove the value attribute if it's empty, so maybe that's why we can't find the form element
								$value = "";
							} else {
								// otherwise, we give up
								$value = show_error("Can't find the form element named \"" + $form_element + "\" in " + $content_file + $check_URL);
							}
						}
					}
				}
			}
		}
		return $value;
	}
	
	function get_setting($source_text, $setting, $allow_override, $allow_partial) {
		// allow most preferences to be overridden through the argument string
		$value = "";
		$setting_no_spaces = $setting;
		$setting_no_spaces = String($setting_no_spaces).replace(/[ -]/g, "_");
		$settings_used += $setting_no_spaces + ",";

		$override = (Request.QueryString($setting_no_spaces) != $undefined) ? String(Request.QueryString($setting_no_spaces)) : "" ;
		if (($allow_override)&&($override != "")) {
			$value = $override;
			// don't allow users to pass code through the URL arguments
			$value = $value.replace(/\</, "&lt;");
			$value = $value.replace(/\>/, "&gt;");
		} else {
			$source_text = "\r" + $source_text; // this makes it easy to make sure settings start on a new line
			if ($allow_partial) {  // this lets us use more verbose labels in the ini file
				$re = new RegExp('[^\\w]' + $setting + '[^:\r]*: ([^\r]*)\r*', 'i');
				if ($re.test($source_text)) {
					$value = RegExp.$1;
				}
			} else {  // this ensures an exact match in the pages file
				$re = new RegExp('[^\\w]' + $setting + ': ([^\r]*)\r*', 'i');
				if ($re.test($source_text)) {
					$value = RegExp.$1;
				}
			}
		}
		if ($value == "0") { $value = 0; } // this ensures that a 0 value will evaluate false in every language
		return $value;
	}

    function get_page_name($page_definition, $source) { // look for a page definition that exactly matches a given dynamic URL
        $page_name = "";
        $source = "\r" + $source; // this makes it easier to match a page definition on the first line of the file
        $re = new RegExp('[^\\w]([-\\w]+)\:\\s+' + regex_quote($page_definition) + '[\&\s\r]', "");
        $page_name = ($re.test($source)) ? RegExp.$1 : "" ;
        return $page_name;
    }
	
	function get_page_names_containing($args, $source) { // look for page definitions that contain a given set of arguments
		$pages = Array();
		$source = "\r" + $source; // this makes it easier to match a page definition on the first line of the file
		$re = new RegExp('[^\\w]([-\\w]+)\:\\s+[^\r]+=' + regex_quote($args) + '[^\r]*[\&\s\r]', "");
		while($re.test($source)) {
			$pages.push(RegExp.$1);
			$source = $source.replace($re, RegExp.$1);
		}
		return $pages;
	}
	
	function get_page_names($source) { // return a list of all the page names in a page definitions file
		$page_names = Array();
		// in JScript, we could also set this up as a global match, then loop through the $matches array
		$re = new RegExp("([-\\w]+)\:\\s+[\\w]+", "");
		while ($re.test($source)) {
			$this_page_name = RegExp.$1;
			$page_names.push($this_page_name);
			$source = $source.replace($re, "");
		}
		return $page_names;
	}
	
	function get_field_names($source, $file_type) { // return a list of all the content fields in a content file -- either HTML or XML depending on the second argument
		$field_names = Array();
		if ($file_type.toLowerCase().indexOf("xml") != -1) {

			$source = make_XML_paths($source);
			$tag_type = "content";
			// in JScript, we could also set this up as a global match, then loop through the $matches array
			$re = new RegExp('<' + $tag_type + '[^>]+name=[\"\']?([-\\w\/]+)[\"\']?[^>]*>', 'i'); // we'd like to use the s flag here, if it existed in ASP
			while ($re.test($source)) {
				$this_field_name = RegExp.$1;
				$field_names.push($this_field_name);
				$source = $source.replace($re, "");
			}

		} else {

			// in JScript, we could also set this up as a global match, then loop through the $matches array
			$re = new RegExp(regex_quote($field_marker) + '([-\\w]+)', "");
			while ($re.test($source)) {
				$this_field_name = RegExp.$1;
				$field_names.push($this_field_name);
				$source = $source.replace($re, "");
			}

		}
		return $field_names;
	}
	
	function get_form_names($source) { // return a list of all the form elements in a content field
		$form_names = new Array();
		$re = new RegExp('<input[^>]+name=[\"\']?([-\\w]+)\\W[^>]*>', 'i'); // we'd like to use the s flag here, if it existed in ASP
		while ($re.test($source)) {
			$this_form_name = RegExp.$1;
			$form_names.push($this_form_name);
			$source = $source.replace($re, "");
		}
		$re = new RegExp('<select[^>]+name=[\"\']?([-\\w]+)\\W[^>]*>', 'i'); // we'd like to use the s flag here, if it existed in ASP
		while ($re.test($source)) {
			$this_form_name = RegExp.$1;
			$form_names.push($this_form_name);
			$source = $source.replace($re, "");
		}
		$re = new RegExp('<textarea[^>]+name=[\"\']?([-\\w]+)\\W[^>]*>', 'i'); // we'd like to use the s flag here, if it existed in ASP
		while ($re.test($source)) {
			$this_form_name = RegExp.$1;
			$form_names.push($this_form_name);
			$source = $source.replace($re, "");
		}
		return $form_names;
	}
	
	function make_XML_paths($source) { // rewrite nested XML content as flat content with paths for tag names; assumes no more than one tag per line
		$source = $source.split("\r");
		$path = Array();
		for ($n=0; $n < $source.length; $n++) {
			$this_line = $source[$n];
			$re = new RegExp("<group[^>]+name=[\"\']?([-\\w\\s]+)[\"\']?[^>]*>", "i");
			$re3 = new RegExp("<content[^>]+name=[\"\']?([-\\w\\s]+)[\"\']?[^>]*>", "i");
			if ($re.test($this_line)) {
				$group_name = RegExp.$1;
				$path.push($group_name); // add the new group name to the path array
			} else if ($this_line.indexOf("</group>") != -1) {
				$group_name = $path.pop(); // remove the latest group name from the path array
			} else if ($re3.test($this_line)) {
				$field_name = RegExp.$1;
				if ($path.length > 0) {
					$current_path = $path.join("/");
					$field_name = $current_path + "/" + $field_name;
					$this_line = $this_line.replace(/(<content[^>]+name=[\"\']?)[-\w]+([\"\']?[^>]*>)/i, "$1"+$field_name+"$2");
					$source[$n] = $this_line;
				}
			}
		}
		$source = $source.join("\r");
		return $source;
	}
	
	function get_directory_listing($directory) { // return a list of all the items in the specified directory
		$files = new Array();
		FSO = Server.CreateObject("Scripting.FileSystemObject");
		if (FSO.FolderExists(absolute_path($directory, "filesystem"))) {
			$dir = FSO.GetFolder(absolute_path($directory, "filesystem"));
			$dir_files = new Enumerator($dir.Files);
			if ($dir_files) {
				for (; !$dir_files.atEnd(); $dir_files.moveNext()) { // what the heck...
					$file = $dir_files.item().Name;
					if ($file.substr(0, 1) != ".") { $files.push($file); } // that gets files that don't start with a dot
				}
			}
			// in ASP, we have to do this once for files and once for folders
			$dir_folders = new Enumerator($dir.Subfolders);
			if ($dir_folders) {
				for (; !$dir_folders.atEnd(); $dir_folders.moveNext()) { // what the heck...
					$file = $dir_folders.item().Name;
					if ($file.substr(0, 1) != ".") { $files.push($file); } // that gets files that don't start with a dot
				}  
			}
		}
		FSO = "";
		return $files;
	}
		
	function get_recursive_listing($start_folder, $recursive, $filter) { // return a list of all the files in a given folder, including subfolders
		$start_folder = $start_folder.replace(/[\/\\]$/, ""); // remove a trailing slash
		$file_list = new Array();
		$folder_list = new Array($start_folder);
		while ($folder_list.length > 0) {
			$this_folder_path = $folder_list[0];
			$this_folder_items = get_directory_listing($this_folder_path);
			for ($n=0; $n<$this_folder_items.length; $n++) {
				$this_item_name = $this_folder_items[$n];
				$this_item_path = $this_folder_path + "/" + $this_item_name;
 				// if the item name contains a dot, we assume it's a file, if not, we assume it's a directory
 				if ($this_item_name.indexOf(".") == -1) {
 					// we've found a folder; add it to the list of folders to scan
 					if ($recursive) {
						$folder_list.push($this_item_path);
					}
				} else if ((!$filter)||($this_item_name.indexOf($filter) != -1)) {
					// we've found a file; add it to the list of files to return
					$this_item_path = $this_item_path.replace($start_folder+"/", ""); // make results relative to the start folder, not to the site
					$file_list.push($this_item_path);
				}
			}
			$folder_list.shift(); // remove the folder we just scanned from the list
		}
		return $file_list;
	}
	
	function process_tag_nav($this_type) {

		// if we haven't already loaded the page definitions file, do that now
		if (! $page_definitions ) { $page_definitions = get_file($read_page_definitions_from[0], "filesystem", 1); }
		
		// if we came here from the expanded URL and not the page shortcut, get the page name now
		if (! $page) { $page = get_page_name($page_definition, $page_definitions); }
		
		$nav_page = $page;
		
		$nav_pages = Array();
		$nav_page_position = 0;
		$count_pages = 0;
		
		// find the block of pages (separated by double line breaks) that this page belongs to
		// first, split the page definitions file up into blocks
		$pages_blocks = "\r\r" + $page_definitions + "\r\r";
		$pages_blocks = $pages_blocks.replace(/\r\r/g, "\r\r\r");
		$re_fn = new RegExp('.*\r\r(.*?\\W' + $nav_page + ': .*?)\r\r.*', "");
		if ($re_fn.test($pages_blocks)) {
			// then find the block that contains this page
			$nav_block = RegExp.$1;
			$nav_block = $nav_block.replace(/\:[ ]*[^\r]*/g, "");
			$nav_block = $nav_block.replace(/^\r*(.*)\r*$/, "$1"); // no trim function?
			$nav_pages = $nav_block.split("\r");
			$count_pages = $nav_pages.length;
		}
		for ($k=0; $k<$count_pages; $k++) {
			// finally, parse through it to find this page's position in the block
			if (String($nav_pages[$k]).toLowerCase() == String($nav_page).toLowerCase()) {
				$nav_page_position = $k+1;
				$k = $count_pages; // stop the loop
			}
		}
					
		if ($this_type.indexOf("nav_current") != -1) {
			$content = Math.round($nav_page_position); // return the position of the current page
		} else if ($this_type.indexOf("nav_total") != -1) {
			$content = $count_pages; // return the number of pages in this block
		} else if ($this_type.indexOf("nav_first") != -1) {
			$content = $nav_pages[0]; // return the name of the first page
		} else if ($this_type.indexOf("nav_last") != -1) {
			$content = $nav_pages[$count_pages - 1]; // return the name of the last page
		
		} else {

			// don't bother with the next part, if the current page doesn't exist
			if ($nav_page_position > 0) {
		
				if ($this_type.indexOf("nav_next") != -1) {
					$result_page_position = $nav_page_position + 1;
					if ($result_page_position > $count_pages) { $result_page_position = 1; }
					$content = $nav_pages[$result_page_position - 1]; // return the name of the requested page
				} else if ($this_type.indexOf("nav_previous") != -1) {
					$result_page_position = $nav_page_position - 1;
					if ($result_page_position < 1) { $result_page_position = $count_pages; }
					$content = $nav_pages[$result_page_position - 1]; // return the name of the requested page
				}
				
			} else {
				$content = show_error("Can't find the page named \"" + $nav_page + "\" in " + $read_page_definitions_from[0]);
			}
			
		}
		
		return $content;
	}
	
	function process_tag_env($this_type) {
		$re_fn = new RegExp("env_(.+)", "i");
		$temp = $re_fn.test($this_type);
		$variable = RegExp.$1;
		if ($variable.toLowerCase().indexOf("last_mod") != -1) {
			$content = $latest_mod_date_formatted;
		} else {
			$content = (Request.ServerVariables($variable.toUpperCase()) != $undefined) ? String(Request.ServerVariables($variable.toUpperCase())) : "" ;
		}
		return $content;
	}

	function show_error($message) {
		
		// prepare the shown message by removing quote marks
		$message_show = $message;
		$message_show = $message_show.replace(/"/g, "&quot;");
		$message_show = $message_show.replace(/'/g, "&#039;");
		$message_show = "<table cellpadding=\"4\" border=\"1\"><tr><td class=\"error-text\"><b>Assembler error</b><br>" + $message_show + "</td></tr></table>";
		
		// prepare the hidden message by removing <br> tags
		$message_hide = $message_show;
		$message_hide = $message_hide.replace(/<br>/, ";");
		$message_hide = "<!-- Assembler error: " + $message_hide + " -->";
		
		// prepare the logged message by removing all but the first line
		$message_log = $message;
		if ($message_log.indexOf("<br>") != -1) {
			$message_log = $message_log.substr(0, $message_log.indexOf("<br>"));
		}
		$message_log = strip_tags($message_log); // also remove any HTML formatting from it
		
		// add the log message to the ongoing error log
		if ($error_log) { $error_log += ","; } // and comma-delimit multiple errors on a page
		$error_log += $message_log;
		
		// add the shown and hidden messages to the output
		if (($show_errors)&&($formulator_fill != "-1")) {
			// only display one error at a time, since subsequent errors are usually a result of the first one
			if ($output.indexOf("Assembler error") == -1) {
				return $message_show;
			} else {
				return "";
			}
		} else {
			return $message_hide;
		}
		
	}
	
	function relative_path($path, $subfolder) { // takes a reference to a file within our site and changes the initial delimiters if necessary
		$this_read_file = 0; $authenticated = 1; $error = ""; $validate_path = 0;
		$path = String($path).replace(/:\/\//g, "");  // don't allow files from other servers
		if ($path.indexOf("/") != -1) { $validate_path = 1; } // we can skip the validation if we just have a file directly the content folder
		if (($path.substr(0,3) != "../")&&($path.substr(0,2) != "./")) {
			// if the path doesn't include a site subfolder, add the subfolder we passed in
			if ($subfolder) { $subfolder += "/"; }
			$path = "../" + $subfolder + $path;
		}
		if ($validate_path) {
			// allow for nonstandard paths, if they're listed in the ini file
			if ($read_files_from) {
				for ($n=0; $n < $read_files_from_count; $n++) {
					if ($read_files_recursively) {
						// allow matches to subfolders
						if ($path.substr(0, $read_files_from[$n].length) == $read_files_from[$n]) { $this_read_file = 1; }
					} else {
						// require an exact match to this folder
						$path_no_filename = $path.replace(/(.*\/)[^\/]*/, "$1");
						if ($path_no_filename == $read_files_from[$n]) { $this_read_file = 1; }
					}
				}
			}
			//$output += "<p>this_read_file: " + $this_read_file + "<p>";  // debug
			if (! $this_read_file) {
				$re = new RegExp("(.*\/)[^\/]*", "i");
				if ($re.test($path)) { $path_trimmed = RegExp.$1; }
				$error = show_error("Not authorized to read from the path \"" + $path_trimmed + "\"<br>Hint: Add nonstandard paths to \"read files from\" list in preferences.ini");
			}
		}
		if ((! $error)&&($require_authentication)) {
			// see if we require authentication to view this page and show an error if necessary
			for ($n=0; $n<$require_authentication_count; $n++) {
				if ($path.substr(0, $require_authentication[$n].length) == $require_authentication[$n]) {
					$authenticated = ($login) ? 1 : 0 ;
					break;
				}
			}
			if (! $authenticated) {
				$re = new RegExp("(.*\/)[^\/]*", "i");
				if ($re.test($path)) { $path_trimmed = RegExp.$1; }
				$error = show_error("Not authorized to read from the path \"" + $path_trimmed + "\"<br>Hint: Log in to \"require authorization to read files from\" list in preferences.ini");
				//Response.Status = "HTTP/1.0 403 Not Authorized"; // how can we make this work, along with the 404 header above?
			}
		}
		if ($error) {
			return $error;
		} else {
			return $path;
		}
	}
	
	function absolute_path($path, $method) { // convert a reference to a file within our site to a complete filesystem path or absolute URL

		if ($method == "filesystem") {
		
			//if ($script_location == "NA") {
			//	$output += show_error("Couldn't determine the filesystem path to this script. Please ensure that either the SCRIPT_FILENAME or PATH_TRANSLATED variable is available on your server.");
			//} else {
				$path = Server.MapPath($path);
			//}

		} else {
		
			if ($request == "NA") {
				$output += show_error("Couldn't determine the web path to this script. Please ensure that either the SCRIPT_NAME or REQUEST_URI variable is available on your server.");
			} else {
				$thisserver = (Request.ServerVariables("HTTP_HOST") != $undefined) ? String(Request.ServerVariables("HTTP_HOST")) : "" ;
				$thispath = "";
				if ($URL_rewriting_flag) {
					$re = new RegExp("\/([^=]*\/)" + $URL_rewriting_flag + "\/", "i");
					if ($re.test($request)) { $thispath = RegExp.$1; }
				} else {
					$re = new RegExp("\/([^=]*\/)contemplate\/", "i");
					if ($re.test($request)) { $thispath = RegExp.$1; }
				}
				
				// pass along the authentication information if present
				$auth_info = (Request.ServerVariables("HTTP_AUTHORIZATION") != $undefined) ? String(Request.ServerVariables("HTTP_AUTHORIZATION")) : "" ;
				if (($auth_info)&&($auth_info.substr(0, 5) == "Basic")) {
					$auth_info = $auth_info.substr(5);
					$login = Base64Decode($auth_info);
					$login += "@";
				} else {
					$login = "";
				}
				
				$path = $path.replace("../", "http://" + $login + $thisserver + "/" + $thispath, ""); // replace the first updelim with the scheme and path
				$path = $path.replace("../", "", "g"); // remove additional updelims
			}
		
		}
		
		return $path;
	}

	function parse_int($str) { // remove all but numeric characters from a string and convert to an integer
		$str = $str.replace(/\D/g, "");
		$int = round($str);
		return $int;
	}

	function make_preview($before_str, $str, $after_str) { // return a little bit before and a little bit after the selected text (used for search results)
		$ellipses_before = ($before_str.length > $search_results_preview_length) ? "..." : "" ;
		$ellipses_after = ($after_str.length > $search_results_preview_length) ? "..." : "" ;
		$before_str = $before_str.substr(-(Math.round($search_results_preview_length / 2)));
		$after_str = $after_str.substr(0, Math.round($search_results_preview_length / 2));
		$before_str = $before_str.replace(/^\s+/, "");
		$after_str = $after_str.replace(/\s+$/, "");
		$preview = $ellipses_before + $before_str + "<b>" + $str + "</b>" + $after_str + $ellipses_after;
		return $preview;
	}

	function regex_quote($source) { // escape any metacharacters in the string; this is a substitute for PHP's preg_quote() built-in function
		// PHP escapes: . \\ + * ? [ ^ ] $ ( ) { } = ! < > | :
		$source = $source.replace(/\\/g, "\\\\");
		$source = $source.replace(/\./g, "\\.");
		$source = $source.replace(/\+/g, "\\+");
		$source = $source.replace(/\*/g, "\\*");
		$source = $source.replace(/\?/g, "\\?");
		$source = $source.replace(/\[/g, "\\[");
		$source = $source.replace(/\^/g, "\\^");
		$source = $source.replace(/\]/g, "\\]");
		$source = $source.replace(/\$/g, "\\$");
		$source = $source.replace(/\(/g, "\\(");
		$source = $source.replace(/\)/g, "\\)");
		$source = $source.replace(/\{/g, "\\{");
		$source = $source.replace(/\}/g, "\\}");
		$source = $source.replace(/\//g, "\\/");
		return $source;
	}

	function strip_tags($str) { // remove all HTML or other markup from text; this is a substitute for PHP's strip_tags() built-in function
		$str = $str.replace(/>[\r\s]</g, "><");
		$str = $str.replace(/<[^>]*>/g, "");
		$str = $str.replace(/^\s*/, "");
		$str = $str.replace(/\s*$/, "");
		return $str;
	}
	
	function random_string($strlen) { // return a string of alphanumeric characters $strlen long
		$chars = "0123456789bcdfghjklmnpqrstvwxyzBCDFGHJKLMNPQRSTVWXYZ";
		$str = "";
		for ($n=0; $n<$strlen; $n++) {
			$str += $chars.substr(Math.round(Math.random() * ($chars.length - 1)), 1);
		}
		return $str;
	}
	
%>

<script language="VBScript" runat="Server">

	' execute some VBScript code; this lets us embed both JScript and VBScript into our pages

	Function eval_VB(ByVal VB_piece)
	  execute(VB_piece)
	End Function


	' decode a base64-encoded string; this is a substitute for PHP's base64_decode() built-in function
	' http://www.webtutoriallist.com/list/finance.asp?url=http://www.pstruh.cz/tips/detpg_Base64.htm&name=Base64+decode+and+basic+authentication%20%20tutorial%20web%20page!

	Function Base64Decode(ByVal base64String)
	  'rfc1521
	  '1999 Antonin Foller, PSTRUH Software, http://pstruh.cz
	  Const Base64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"
	  Dim dataLength, sOut, groupBegin
	  
	  'remove white spaces, If any
	  base64String = Replace(base64String, vbCrLf, "")
	  base64String = Replace(base64String, vbTab, "")
	  base64String = Replace(base64String, " ", "")
	  
	  'The source must consists from groups with Len of 4 chars
	  dataLength = Len(base64String)
	  If dataLength Mod 4 <> 0 Then
		Err.Raise 1, "Base64Decode", "Bad Base64 string."
		Exit Function
	  End If
	
	  
	  ' Now decode each group:
	  For groupBegin = 1 To dataLength Step 4
		Dim numDataBytes, CharCounter, thisChar, thisData, nGroup, pOut
		' Each data group encodes up To 3 actual bytes.
		numDataBytes = 3
		nGroup = 0
	
		For CharCounter = 0 To 3
		  ' Convert each character into 6 bits of data, And add it To
		  ' an integer For temporary storage.  If a character is a '=', there
		  ' is one fewer data byte.  (There can only be a maximum of 2 '=' In
		  ' the whole string.)
	
		  thisChar = Mid(base64String, groupBegin + CharCounter, 1)
	
		  If thisChar = "=" Then
			numDataBytes = numDataBytes - 1
			thisData = 0
		  Else
			thisData = InStr(Base64, thisChar) - 1
		  End If
		  If thisData = -1 Then
			Err.Raise 2, "Base64Decode", "Bad character In Base64 string."
			Exit Function
		  End If
	
		  nGroup = 64 * nGroup + thisData
		Next
		
		'Hex splits the long To 6 groups with 4 bits
		nGroup = Hex(nGroup)
		
		'Add leading zeros
		nGroup = String(6 - Len(nGroup), "0") & nGroup
		
		'Convert the 3 byte hex integer (6 chars) To 3 characters
		pOut = Chr(CByte("&H" & Mid(nGroup, 1, 2))) + _
		  Chr(CByte("&H" & Mid(nGroup, 3, 2))) + _
		  Chr(CByte("&H" & Mid(nGroup, 5, 2)))
		
		'add numDataBytes characters To out string
		sOut = sOut & Left(pOut, numDataBytes)
	  Next
	
	  Base64Decode = sOut
	End Function

</script>

<%

// set up some error messages that we can use later

	$check_URL = "<br>Hint: Check your page definition";
	$check_embed = "<br>Hint: Check your embed tag";
	$check_field_label = "<br>Hint: Check your content file and remove any formatting tags between the field marker and the field label";
	$change_tag_name = "<br>Hint: Choose a different name for this embed tag";
	

// set up some primary variables

	// try to figure out the path to this script as it appears in the browser, before any URL rewriting
	// in IIS, this probably won't work, because REQUEST_URI will either not exist, or will show the path after rewriting, since rewriting is handled externally from IIS
	$request = "NA";
	if (Request.ServerVariables("REQUEST_URI") != $undefined) {
		$request = String(Request.ServerVariables("REQUEST_URI"));
		if ($request.indexOf("?") != -1) {
			$request = $request.substr(0, $request.indexOf("?"));
		}
	} else {
		// IIS doesn't always provide the REQUEST_URI variable
		if (Request.ServerVariables("SCRIPT_NAME") != $undefined) {
			$request = String(Request.ServerVariables("SCRIPT_NAME"));
		}
	}

	// if we know the browser path, figure out the part that triggers the rewrite; assume this is just one virtual directory name
	$re = new RegExp("contemplate/assembler", "");
	if (!$re.test($request)) {
		$re = new RegExp("([^\/]*)\/[^\/]+$", "i");
		if ($re.test($request)) { $URL_rewriting_flag = RegExp.$1; }
	} else {
		$URL_rewriting_flag = "";
	}

	// figure out the full local path of the contemplate directory so we can build an absolute path that works on Windows computers
	// on Unix, this will include any symlinks used to construct the URL, so we can run the script from a symlink to the real contemplate folder, 
	// and paths will be relative to the apparent, rather than the actual, location of assembler.asp
	// on Windows, this will not include virtual directories, but constructing a path from a virtual directory wouldn't work anyway
	// because those aren't available at the file system level
	$script_location = "NA";
	if (Request.ServerVariables("SCRIPT_FILENAME") != $undefined) {
		$script_location = String(Request.ServerVariables("SCRIPT_FILENAME"));
	} else {
		// Windows doesn't provide the SCRIPT_FILENAME variable
		if (Request.ServerVariables("PATH_TRANSLATED") != $undefined) {
			$script_location = String(Request.ServerVariables("PATH_TRANSLATED"));
		}
	}
	$script_location = $script_location.replace(/\\/g, "/");
	$re = new RegExp("(.*\/)" + $URL_rewriting_flag + "\/", "i");
	if (($URL_rewriting_flag)&&($re.test($script_location))) {
		$script_location = RegExp.$1 + "contemplate/";
	} else {
		$re = new RegExp("(.*\/)[^\/]+", "");
		if ($re.test($script_location)) { $script_location = RegExp.$1; }
	}

	
// read in a preferences (.ini) file if one exists, and show which preferences may be overridden from the URL string

	$preferences = get_file("data/preferences.ini", "filesystem", 0);
	if ($preferences) {
		$field_marker = get_setting($preferences, "field marker", 1, 1);
		$log_traffic = get_setting($preferences, "log site traffic", 1, 1);
		$show_errors = get_setting($preferences, "show errors", 1, 1);
		$pre_render_files = get_setting($preferences, "pre-render files", 1, 1);
		$read_page_definitions_from = get_setting($preferences, "read page definitions from", 1, 1);
		$read_files_from = get_setting($preferences, "read files from", 0, 1);
		$read_files_recursively = get_setting($preferences, "read files recursively", 0, 1);
		$require_authentication = get_setting($preferences, "require authentication", 0, 1);
		$prevent_page_caching = get_setting($preferences, "prevent page caching", 1, 1);
		$show_expanded_URLs = get_setting($preferences, "show expanded URLs", 1, 1);
		$split_page_names_on = get_setting($preferences, "split page names on", 1, 1);
		$external_link_target = get_setting($preferences, "external link target", 1, 1);
		$search_results_preview_length = get_setting($preferences, "preview length", 1, 1);
		$line_ending = get_setting($preferences, "line ending", 1, 1);
		$show_source = get_setting($preferences, "show source", 1, 1);
		$show_source_to = get_setting($preferences, "show source to", 0, 1);
		$host_lookups = get_setting($preferences, "host lookups", 1, 1);
		$track_visitors = get_setting($preferences, "track visitors", 1, 1);
	} else {
		$field_marker = "";
		$log_traffic = "";
		$show_errors = "";
		$pre_render_files = "";
		$read_page_definitions_from = "";
		$read_files_from = "";
		$read_files_recursively = "";
		$require_authentication = "";
		$prevent_page_caching = "";
		$show_expanded_URLs = "";
		$split_page_names_on = "";
		$external_link_target = "";
		$search_results_preview_length = "";
		$line_ending = "";
		$show_source = "";
		$show_source_to = "";
		$host_lookups = "";
		$track_visitors = "";
	}
	
		
// do a bit of processing on the settings, and set some defaults in case preferences.ini or individual settings are absent

	if ($field_marker == "") { $field_marker = "##"; }
	
	if ($show_errors === "") { $show_errors = "1"; }
	$show_errors = parseFloat($show_errors);

	if (($pre_render_files)&&($pre_render_files != "1")&&($pre_render_files != "0")) {
		$pre_render_files = $pre_render_files.replace(/, /g, ",");
		$pre_render_files = $pre_render_files.split(",");
	}
	
	//if ($read_page_definitions_from == "") { $read_page_definitions_from = "../contemplate/pages.txt"; }
	if ($read_page_definitions_from) {
		$read_page_definitions_from = $read_page_definitions_from.replace(/, /g, ",");
		$read_page_definitions_from = $read_page_definitions_from.split(",");
	} else {
		$read_page_definitions_from = new Array("data/pages.txt");
	}
	$read_page_definitions_from_count = $read_page_definitions_from.length;

	if ($read_files_from.indexOf("../contemplate/") == -1) { $read_files_from += ", ../contemplate/"; }
	if ($read_files_from.indexOf("../contemplate/data/") == -1) { $read_files_from += ", ../contemplate/data/"; }
	if ($read_files_from.indexOf("../content/") == -1) { $read_files_from += ", ../content/"; }
	if ($read_files_from.indexOf("../templates/") == -1) { $read_files_from += ", ../templates/"; }
	$re = new RegExp("^, (.*)", "");
	if ($re.test($read_files_from)) { $read_files_from = RegExp.$1; }
	if ($read_files_from) {
		$read_files_from = $read_files_from.replace(/, /g, ",");
		$read_files_from = $read_files_from.split(",");
	} else {
		$read_files_from = new Array();
	}
	$read_files_from_count = $read_files_from.length;

	if ($read_files_recursively === "") { $read_files_recursively = "1"; }
	$read_files_recursively = parseFloat($read_files_recursively);

	if ($require_authentication) {
		$require_authentication = $require_authentication.replace(/, /g, ",");
		$require_authentication = $require_authentication.split(",");
	} else {
		$require_authentication = new Array();
	}
	$require_authentication_count = $require_authentication.length;

	if ($show_expanded_URLs === "") { $show_expanded_URLs = "0"; }
	$show_expanded_URLs = parseFloat($show_expanded_URLs);

	if ($search_results_preview_length == "") { $search_results_preview_length = 128; }

	if ($line_ending == "") {
		$line_ending = "\n";
	} else {
		$line_ending = $line_ending.replace(/"/g, "\\\"");
		eval('$line_ending = "' + $line_ending + '"');
	}

	$show_source = parseFloat($show_source);

	if ($show_source_to) {
		$show_source_to = $show_source_to.replace(/, /g, ",");
		$show_source_to = $show_source_to.split(",");
		$show_source_to_count = $show_source_to.length;
	}

	if ($host_lookups == "") { $host_lookups = "auto"; }

	if ($track_visitors === "") { $track_visitors = "0"; }
	$track_visitors = parseFloat($track_visitors);


// check to see if the user is logged in via basic authentication

	$auth_info = (Request.ServerVariables("HTTP_AUTHORIZATION") != $undefined) ? String(Request.ServerVariables("HTTP_AUTHORIZATION")) : "" ;
	if (($auth_info)&&($auth_info.substr(0, 5) == "Basic")) {
		$auth_info = $auth_info.substr(5);
		$login = Base64Decode($auth_info);
	} else {
		$login = "";
	}


// generate an SQL-standard timestamp

	$date = new Date();
	$year = $date.getFullYear();
	$month = $date.getMonth() + 1; if ($month < 10) { $month = "0" + String($month); }
	$day = $date.getDate(); if ($day < 10) { $day = "0" + String($day); }
	$hour = $date.getHours(); if ($hour < 10) { $hour = "0" + String($hour); }
	$minute = $date.getMinutes(); if ($minute < 10) { $minute = "0" + String($minute); }
	$second = $date.getSeconds(); if ($second < 10) { $second = "0" + String($second); }
	$SQL_timestamp = $year + "-" + $month + "-" + $day + " " + $hour + ":" + $minute + ":" + $second;
		

// write an HTTP header to prepare for text output

	$header += "Content-type: text/html\r";
	if ($prevent_page_caching) {
  		// trick the browser into getting a new page every time
  		$header += "Pragma: no-cache\r";
		$header += "Cache-control: no-cache\r";
		$header += "Expires: Mon, 07 May 1973 00:00:00 GMT\r";
		// ASP could also use: Response.Expires(0);
	}
	if (($track_visitors)&&(String(Request.Cookies("Contemplate")) == "")) {
		// if we want to track visitors and this visitor doesn't have a Contemplate cookie yet, generate a visitor ID and save it to the cookie (this assumes that if they have the cookie, it contains a visitor ID)
		$SQL_timestamp_stripped = $SQL_timestamp.replace(/\D/g, "");
		$visitor_ID = random_string(16) + "-" + $SQL_timestamp_stripped;
		$today_date = new Date();
		$today_year = $today_date.getFullYear();
		$today_month = $today_date.getMonth();
		$today_day = $today_date.getDate();
		$expires_date = new Date($today_year + 10, $today_month, $today_day);
		$expires = $expires_date.toUTCString();
		$header += "Set-Cookie: Contemplate=visitor_ID%3D" + $visitor_ID + "; Expires=" + $expires + "; Path=/; Version=1";
	}


// parse the URL to figure out the arguments for this page

	$page = (Request.QueryString("page") != $undefined) ? String(Request.QueryString("page")) : "" ;
	$requested_page = (Request.QueryString("requested_page") != $undefined) ? String(Request.QueryString("requested_page")) : "" ;
	if ($page) {
		// look in the page definitions file(s)...
		$page_definition = "";
		for ($i=0; $i<$read_page_definitions_from_count; $i++) {
			$this_read_page_definitions_from = $read_page_definitions_from[$i];
			$this_read_page_definitions_from = relative_path($this_read_page_definitions_from, "contemplate");
			if ($this_read_page_definitions_from.toLowerCase().indexOf("not authorized") != -1) {
				$output += $this_read_page_definitions_from;
			} else {
				$page_definitions = get_file($this_read_page_definitions_from, "filesystem", 1);
				if ($file_missing) {
					$output += $page_definitions; // $page_definitions will contain the error message generated by get_file()
				} else {
					$page_definition = get_setting($page_definitions, $page, 0, 0);
					if ($page_definition) { // CHECK FOR THE PRESENCE OF THE TEMPLATE VALUE ELSEWHERE
						// let any real-time args tag along for the ride
						$more_args = (Request.ServerVariables("QUERY_STRING") != $undefined) ? unescape(String(Request.ServerVariables("QUERY_STRING"))) : "" ;
						$more_args = $more_args.replace(/&?page=[^&]+/, "");
						if ($more_args) { $page_definition += "&" + $more_args; }
						$page_definition = $page_definition.replace(/&+/g, "&");
						if ($show_expanded_URLs) {
							// redirect to the page with the full URL visible
							$page_definition = $page_definition.replace(/&show_expanded_URLs=1/, "");
							$page_definition += "&requested_page=" + $page;
							Response.redirect("../contemplate/assembler.asp?" + $page_definition);
							//exit;
						}
						$i = $read_page_definitions_from_count;
					}
				}
			}
		}
		if ($page_definition == "") {
			$read_page_definitions_from_plural = ($read_page_definitions_from_count > 1) ? "s" : "" ;
			$output += show_error("Can't find a definition for \"" + $page + "\" in the file" + $read_page_definitions_from_plural + " " + $read_page_definitions_from.join(", ") + ".");
			//Response.Status = "404 Not Found"; // this doesn't seem to affect the response from IIS
			//Response.AddHeader("Status", "404 Not Found"); // is this redundant?
		}
	} else {
		// ...or just use the current URL
		$page_definition = (Request.ServerVariables("QUERY_STRING") != $undefined) ? unescape(String(Request.ServerVariables("QUERY_STRING"))) : "" ;
		if ($requested_page) { $page = $requested_page; }
	}
	
	// remove our own arguments from the page definition if present
	$page_definition = $page_definition.replace(/&formulator_fill=1/, "");
	$page_definition = $page_definition.replace(/&show_info=1/, "");
	
	// don't proceed from here unless we have a page definition
	if ($page_definition) {
	
		// create arrays from the argument values, so we can more easily refer to their individual parts
		$args = $page_definition.split("&");
		$args_count = $args.length;
		for ($i=0; $i<$args_count; $i++) {
			$pair = $args[$i].split("=");
			$key = $pair[0];
			$key = $key.toLowerCase(); // argument names are hereby declared case-insensitive
			// skip args that have the same name as a preference setting, so that we can control which settings can be overridden
			if ((","+$settings_used+",").indexOf(","+$key+",") == -1) {
				$value = ($pair.length > 1) ? $pair[1] : "" ;
				// don't allow users to pass code through the URL arguments
				$value = $value.replace(/\</, "&lt;");
				$value = $value.replace(/\>/, "&gt;");
				if ($value.indexOf(",") != -1) {
					eval('$' + $key + ' = $value.split(",")');
				} else {
					if ($key.indexOf("template") == -1) {
						eval('$' + $key + ' = Array()');
						eval('$' + $key + '[0] = $value');
					} else {
						$template = $value;
					}
				}
			}
		}
		
	
// grab the text of the template file
	
		if ($template) {
			$template_text = relative_path($template, "templates");
			if ($template_text.toLowerCase().indexOf("not authorized") == -1) { // if there's an error, leave the error in the template_text variable to display it
				$template_text = get_file($template_text, "auto", 1);
			}
		} else {
			$template_text = "<!--#embed args -->"; // allow display of one piece of content directly, with no template
		}
		$output += $template_text;


// make the core processing recursive (e.g. process embed tags in embedded content)

		$i = 1;
		$re4 = new RegExp("<!--\#\s*embed.*-->", "i"); // we'd like to use the s flag here, if it existed in ASP
		$re5 = new RegExp("<!--\#\s*if.*-->", "i"); // we'd like to use the s flag here, if it existed in ASP
		while ($re4.test($output)||$re5.test($output)) {

// process any conditional tags to hide pieces of the template
	
			// first, find and number all if/else/end if sets
			$levels = Array();
			$greatest = 0;
			while ($output.search(/<!--\#\s*end[ ]*if\D/i) != -1) {
				// which is next, an if, else, or end if?
				$re = new RegExp("<!--\#\\s*if[^\\d](.*)", "i");
				if ($re.test($output)) { $length_after_if = RegExp.$1.length; } else { $length_after_if = -1; }
				$re = new RegExp("<!--\#\\s*else[^\\d](.*)", "i");
				if ($re.test($output)) { $length_after_else = RegExp.$1.length; } else { $length_after_else = -1; }
				$re = new RegExp("<!--\#\\s*end[ ]*if[^\\d](.*)", "i");
				if ($re.test($output)) { $length_after_end_if = RegExp.$1.length; } else { $length_after_end_if = -1; }
				if (($length_after_if > $length_after_end_if)&&($length_after_if > $length_after_else)) {
					$greatest++;
					$levels.push($greatest);
					$output = $output.replace(/<!--\#\s*if(\D)/i, "<!--#if" + $greatest + "$1");
					//$output += "<br>adding if " + $greatest;  // debug
				} else if (($length_after_else > $length_after_if)&&($length_after_else > $length_after_end_if)) {
					$next = $levels[$levels.length - 1];
					$output = $output.replace(/<!--\#\s*else(\D)/i, "<!--#else" + $next + "$1");
					//$output += "<br>adding else " + $next;  // debug
				} else {
					$next = $levels.pop();
					$output = $output.replace(/<!--\#\s*end[ ]*if(\D)/i, "<!--#end if" + $next + "$1");
					//$output += "<br>adding end if " + $next;  // debug
				}
			}
			
			// then evaluate and process each of them
			// in JScript, we could also set this up as a global match, then loop through the $matches array
			$re2 = new RegExp("<!--\#\\s*if(\\d+)[ ]*\\(([^\r<]*[^ ])\\)[ ]*-->", "i");
			while ($re2.test($output)) {  // ignore extra spaces around "if" and expression
				$j = RegExp.$1;
				$this_expression = RegExp.$2;
				$native_expression = $this_expression;
	
				// the variable symbol $ is optional in the template; add it here if it's missing
				if ($native_expression.search(/\$[_\w]+\[/) == -1) {
					$native_expression = $native_expression.replace(/([_\w]+\[)/g, $field_marker+"$1"); // we need an extra step here because JScript won't let us use $$1 as the replace value
					$re = new RegExp($field_marker, "g");
					$native_expression = $native_expression.replace($re, "$");
				}
				
				// these variables don't exist internally as arrays; this fakes it so they're still available in conditional tags
				if (($split_page_names_on != "")&&($native_expression.search(/\$page\[\d+\]/i) != -1)) {
					$page_array = $page.split($split_page_names_on);
					$native_expression = $native_expression.replace(/\$page\[(\d+)\]/i, "\$page_array[$1]");
				} else {
					$native_expression = $native_expression.replace(/\$page\[\d*\]/i, "\$page");
				}
				$native_expression = $native_expression.replace(/\$template\[\d*\]/i, "\$template");
				$native_expression = $native_expression.replace(/\$page_definition\[\d*\]/i, "\$page_definition");
				
				// if an array (other than the special variables above) doesn't have an index, return every element of the array as a string
				$native_expression = $native_expression.replace(/\$([_\w]+)\[\]/i, "!@#!@#!@#" + "$1" + ".join(\",\")");
				$native_expression = $native_expression.replace(/!@#!@#!@#/i, "$"); // for some reason we couldn't just put "$" in the line above; it messed up the $1 that came right after

				// these keywords don't exist as arrays at all; this inserts their values as literal strings so they're available, too
				$re = new RegExp("\\$*(env_\\w+)", "i");
				while($re.test($native_expression)) {
					$native_expression = $native_expression.replace($re, "\"" + process_tag_env(RegExp.$1) + "\"");
				}				
				$re = new RegExp("\\$*(nav_\\w+)", "i");
				while($re.test($native_expression)) {
					$native_expression = $native_expression.replace($re, "\"" + process_tag_nav(RegExp.$1) + "\"");
				}				
				
				// JScript dies if we try to test a variable that hasn't been set, so we have to find all the variables in the expression and test them in a safe way before evaluating it
				$re = new RegExp("\\$([_\\w]+)\\[([^\]])\\]", "i");
				while($re.test($native_expression)) {
					eval("$isset = ((typeof($" + RegExp.$1 + ") != 'undefined')&&($" + RegExp.$1 + ".length > " + RegExp.$2 + "))");
					if ($isset) {
						$native_expression = $native_expression.replace($re, $field_marker + RegExp.$1 + "[" + RegExp.$2 + "]");
					} else {
						$native_expression = $native_expression.replace($re, "\"\"");
					}
				}				
				$re = new RegExp($field_marker, "g");
				$native_expression = $native_expression.replace($re, "$");
				
				//$output += $native_expression + "<br>"; // debug
				eval('$this_evaluates = (' + $native_expression + ')');
				$re = new RegExp('<!--\#\s*if' + $j + '[ ]*\\([^\r<]*[^ ]\\)[ ]*-->(.*)<!--\#\s*end[ ]*if' + $j + '[ ]*-->', "i"); // we'd like to use the s flag here, if it existed in ASP
				if ($re.test($output)) {
					// always show embed tags in the formulator
					$conditional_content = RegExp.$1;
					if (($conditional_content.search(/<!--\#\s*embed/i) != -1)&&($formulator_fill)) { $this_evaluates = 1; }
				}
				$re = new RegExp('<!--\#\\s*else' + $j + '\\D', 'i');
				if ($output.search($re) != -1) {
					if ($this_evaluates) {
						$re = new RegExp('<!--\#\\s*if' + $j + '[ ]*\(([^\r<]*[^ ])\)[ ]*-->', "i"); // remove the if tag... // we'd like to use the s flag here, if it existed in ASP
						$output = $output.replace($re, '');
						$re = new RegExp('<!--\#\\s*else' + $j + '\\D.*end[ ]*if' + $j + '[ ]*-->', "i"); // ...and from the else tag to the end if tag // we'd like to use the s flag here, if it existed in ASP
						$output = $output.replace($re, '');
					} else {
						$re = new RegExp('<!--\#\\s*if' + $j + '\\D.*else' + $j + '[ ]*-->', "i"); // remove from the if tag to the else tag... // we'd like to use the s flag here, if it existed in ASP
						$output = $output.replace($re, '');
						$re = new RegExp('<!--\#\\s*end[ ]*if' + $j + '[ ]*-->', "i"); // ...and the end if tag // we'd like to use the s flag here, if it existed in ASP
						$output = $output.replace($re, '');
					}
				} else {
					if ($this_evaluates) {
						$re = new RegExp('<!--\#\\s*if' + $j + '[ ]*\(([^\r<]*[^ ])\)[ ]*-->', "i"); // remove the if tag // we'd like to use the s flag here, if it existed in ASP
						$output = $output.replace($re, '');
						$re = new RegExp('<!--\#\\s*end[ ]*if' + $j + '[ ]*-->', "i"); // remove the end if tag // we'd like to use the s flag here, if it existed in ASP
						$output = $output.replace($re, '');
					} else {
						$re = new RegExp('<!--\#\\s*if' + $j + '\\D.*end[ ]*if' + $j + '[ ]*-->', "i"); // remove from the if to the end if tag // we'd like to use the s flag here, if it existed in ASP
						$output = $output.replace($re, '');
					}
				}
			}
	
	
// find all the embed tags in the template and replace with temporary placeholders
	
			// in JScript, we could also set this up as a global match, then loop through the $matches array
			// slower: $re2 = new RegExp("(.*?)<!--\#\\s*embed\\s*([^\r]*?[^ ])\\s*-->(.*?)", "i");
			$re2 = new RegExp("(<!--\#\\s*embed\\s*)([^\r]*?[^ ])(\\s*-->)", "i");
			while ($re2.test($output)) {  // ignore extra spaces before embed type, around "embed", and after attributes
			
				// slower: $before_embed = RegExp.$1; $this_embed = RegExp.$2; $after_embed = RegExp.$3;
				$this_embed_complete = RegExp.$1 + RegExp.$2 + RegExp.$3;
				$this_embed = RegExp.$2;
				$this_embed = $this_embed.toLowerCase(); // embed tags are hereby declared case-insensitive
				$this_embed_copy = $this_embed;
				$this_type = "";
				$this_embed_variable = "";
				$this_embed_strip = "";
				$this_embed_replace = new Array();
				$this_embed_fill_defer = "";
				$this_embed_special = "";
				
				if ($this_embed.search(/\s+variable/) != -1) {  // look for a variable attribute, which tells us to save the embed content as a variable rather than add it to the output
					$this_embed_variable = 1;
					$this_embed = $this_embed.replace(/\s+variable/, "");
				}
				
				if ($this_embed.search(/\s+strip/) != -1) {  // look for a strip attribute, which tells us to remove all markup from the embed content
					$this_embed_strip = 1;
					$this_embed = $this_embed.replace(/\s+strip/, "");
				}
				
				if ($this_embed.search(/\s+replace/) != -1) {  // look for a replace attribute, which tells us to do some search-and-replaces on the embed content
					$this_replace_array = Array();
					$re = new RegExp("\\s+replace\\s+\/([^\/]*)\/([^\/]*)\/", "");
					while ($re.test($this_embed)) {
						$search = RegExp.$1; $replace = RegExp.$2;
						$this_replace_array.push($search);
						$this_replace_array.push($replace);
						$re3 = new RegExp("\\s+replace\\s+\/" + regex_quote($search) + "\/" + regex_quote($replace) + "\/", ""); // the other languages can just use the same regexp: "\s+replace\s+\/[^\/]*\/[^\/]*\/"
						$this_embed = $this_embed.replace($re3, "");
					}
					$this_embed_replace = $this_replace_array;
					// $output += "this_replace_array: " + $embeds_replace[$i - 1]; // debug
				}
				
				if ($this_embed.search(/\s+fill_defer/) != -1) { // look for a fill_defer attribute, which tells us put the formulator fill fields at the end of the file
					$this_embed_fill_defer = 1;
					$this_embed = $this_embed.replace(/\s+fill_defer/, "");
				}
				
				$re = new RegExp('<!--\#\\s*embed\\s*' + regex_quote($this_embed_copy) + '\\s*-->', 'ig');
				$output = $output.replace($re, "-embed-" + $i + "-"); // this is global so that if the same embed tag appears more than once, we only have to parse it once
				// $output += "<p>Found embed tag: " + $this_embed + "\r\r";  // debug
		
		
// process each embed tag and replace the placeholders with real content

			// show a warning if we have one of our special variable names; you can't name an embed tag with one of these names
		
				if (($this_embed == "page")||($this_embed == "template")||($this_embed == "page_definition")) {
					$content = show_error("The tag name \"" + $this_embed + "\" is a reserved word<br>Hint: Choose a different name for this embed tag");
					$this_type = "ignore";
				}
				
		
			// get the args if we've hard-coded them into the tag
		
				$re = new RegExp("args[ ]*=[ ]*([^ ]*)", "i");
				if ($re.test($this_embed)) {
					$this_args = RegExp.$1;
					// in JScript, we could also set this up as a global match, then loop through the $matches array
					$re = new RegExp("(\\w+)\\[(\\d*)\\]", "");
					while ($re.test($this_args)) {
						// process passthru/hard-coded combos
						$variable_name = RegExp.$1;
						$variable_index = RegExp.$2;
						// these variables don't exist internally as arrays; this fakes it so they're still available in passthru tags
						if (($variable_name == "page")||($variable_name == "template")||($variable_name == "page_definition")) {
							if (($split_page_names_on != "")&&($variable_name == "page")) {
								if ($variable_index == "") {
									// if no index is specified, return the whole page name
									$value = $page;
								} else {
									$page_array = $page.split($split_page_names_on);
									eval('$value = $page_array[' + $variable_index + ']');
								}
							} else {
								eval('$value = $' + $variable_name);
							}
						} else {
							if ($variable_index == "") {
								// if no index is specified, return the whole array as a string
								eval('$value = $' + $variable_name + '.join(",")');
							} else {
								eval('$value = $' + $variable_name + '[' + $variable_index + ']');
							}
						}
						$key = $variable_name + "[" + $variable_index + "]";
						eval('$this_args = $this_args.replace(/' + regex_quote($key) + '/g, $value)');
					}
					$this_args = $this_args.replace(/\+/g, "");
					$this_embed = "hardcoded"; // it doesn't really matter what we use for the name here
					eval('$' + $this_embed + ' = $this_args.split(",")');
					$this_embed_special = 1;
				}
				
		
			// set the type to passthru if we have a square bracket (and remove the optional $ to avoid errors)
		
				$re = new RegExp("(\\w+)\\[(\\d*)\\]", "");
				if ($re.test($this_embed)) {
					$this_embed = RegExp.$1;
					$this_embed_passthru_index = RegExp.$2;
					$this_type = "passthru";
					if (($this_embed == "page")||($this_embed == "template")||($this_embed == "page_definition")) {
						// treat these as hard-coded values that shouldn't be set in the formulator
						$this_embed_special = 1;
					}
				}
				
		
			// set the type to the name if we have a navigation or environment tag
		
				if (($this_embed.toLowerCase().indexOf("nav_") != -1)||($this_embed.toLowerCase().indexOf("env_") != -1)) {
					$this_type = $this_embed;
					$this_embed_special = 1;
				}
				
		
			// if we don't have any of the previously listed special types, the type is the first argument

				if (! $this_type) {
					eval("$isset = (typeof($" + $this_embed + ") != 'undefined')");
					if ($isset) {
						if ($this_embed != "") {
							eval("$isarray = (typeof($" + $this_embed + "[0]) != 'undefined')");
							if ($isarray) {
								eval("$this_type = $" + $this_embed + "[0]");
							} else {
								// we're dealing with a missing argument that happens to have the same name as an internal variable,
								// or an existing argument that gets overwritten by an internal variable
								// this code doesn't eliminate the need for the page/template/page_definition check above
								// it also doesn't avoid problems with conflicting internal variables that are arrays
								$content = show_error("The tag name \"" + $this_embed + "\" is a reserved word " + $change_tag_name);
								$this_type = "ignore";
							}
						} else {
							$this_type = "skip";
						}
					} else {
						$this_type = "skip";
					}
				}
				
		
			// show popup menus rather than content if we're running from the formulator
		
				if ($formulator_fill) {
				
					// the first time through, strip any form tags from the template so they don't interfere with the popup menus
					if ($i == 1) {
						$output = $output.replace(/<form.*?>/ig, "");
						$output = $output.replace(/<\/form.*?>/ig, "");
					}
					
					// if this isn't a special kind of embed tag, make some menus, or an input box for passthru tags
					if (! $this_embed_special) {
					
						// don't display an input form for any tag more than once, even though it might appear in the template more than once
						$tag_names_flattened = $tag_names.join(",");
						if (("," + $tag_names_flattened + ",").indexOf("," + $this_embed + ",") == -1) {
						
							// if this is a passthru tag but a normal tag by this name appears later in the template, don't do anything now so we can fill out the argument using the menus
							$re = new RegExp("<!--\#\\s*embed\\s*" + $this_embed + "\\s", "i");
							if (!(($this_type.indexOf("passthr") != -1)&&($re.test($output)))) {
							
								if ($this_type.indexOf("passthr") == -1) {
							
									$fill_forms = "";
									
									$fill_forms += "	<b>" + $this_embed.toUpperCase() + "</b>\r";
									$fill_forms += "	<a href=JavaScript:parent.inspect_content('" + $this_embed + "')\r";
									$fill_forms += "	 onmouseover='document.images.inspector_" + $this_embed + ".src=\"graphics/inspector_1.gif\"'\r";
									$fill_forms += "	 onmouseout='document.images.inspector_" + $this_embed + ".src=\"graphics/inspector_0.gif\"'><img \r";
									$fill_forms += "	src=graphics/inspector_0.gif\r";
									$fill_forms += "	 width=12 height=12 hspace=2 border=0\r";
									$fill_forms += "	 name=inspector_" + $this_embed + " alt='Inspect'></a><br>\r\r";
									
									$fill_forms += "	<form name=contemplate_" + $this_embed + ">\r\r";
									
									$fill_forms += "		<select name=embed_type onchange=parent.set_type('" + $this_embed + "')>\r";
									$fill_forms += "			<option value=-1>Embed type...</option>\r";
									$fill_forms += "			<option value=file>File</option>\r";
									$fill_forms += "			<option value=field>Field</option>\r";
									$fill_forms += "			<option value=form>Form</option>\r";
									$fill_forms += "			<option value=random>Random</option>\r";
									$fill_forms += "			<option value=none>None</option>\r";
									$fill_forms += "		</select><br>\r\r";
									
									$fill_forms += "		<img src=../contemplate/graphics/spacer.gif width=1 height=2><br>\r\r";
									
									$fill_forms += "		<select name=embed_file onchange=parent.set_file('" + $this_embed + "')>\r";
									$fill_forms += "			<option value=0>(not needed)</option>\r";
									$fill_forms += "		</select><br>\r\r";
									
									$fill_forms += "		<img src=../contemplate/graphics/spacer.gif width=1 height=2><br>\r\r";
									
									$fill_forms += "		<select name=embed_field onchange=parent.set_field('" + $this_embed + "')>\r";
									$fill_forms += "			<option value=0>(not needed)</option>\r";
									$fill_forms += "		</select><br>\r\r";
									
									$fill_forms += "		<img src=../contemplate/graphics/spacer.gif width=1 height=2><br>\r\r";
									
									$fill_forms += "		<select name=embed_form>\r";
									$fill_forms += "			<option value=0>(not needed)</option>\r";
									$fill_forms += "		</select><p><br>\r\r";
									
									$fill_forms += "	</form>\r\r";
										
									$fill_forms += "";
		
									if ($this_embed_fill_defer != 1) {
										// either display the popup menus right where the embedded content would be, and then stop parsing this tag...
										$content = $fill_forms;
										$this_embed_strip = "";
										$this_embed_replace = new Array();
										$this_embed_variable = "";
										$this_type = "ignore";
									} else {
										// ...or go ahead and parse this tag in place, and show the fill menus at the end of the page
										$output = $output.replace(/<\/html>/, $fill_forms + "</html>");
									}
				
									eval("$isset = (typeof($" + $this_embed + ") != 'undefined')");
									if ($isset) {
										eval("$isfilled = ($" + $this_embed + ".join(\",\") != \"\")");
										if (($this_embed != "")&&($isfilled)) {
											eval("$this_embed_flattened = $" + $this_embed + ".join(\",\")");
											$stored_selections += "parent.show_stored('" + $this_embed + "', '" + $this_embed_flattened + "');\r\t\t\t\t\t\t\t";				
										}
									}
		
								} else {
								
									// process passthru values a little differently -- just show a text field for them
									
									$fill_forms = "";
									
									$fill_forms += "	<b>" + $this_embed.toUpperCase() + "</b><br>\r\r";
									
									$fill_forms += "	<form name=contemplate_" + $this_embed + ">\r\r";
									
									$fill_forms += "		<input type=text size=24 name=embed_value><br>\r\r";
									
									$fill_forms += "	</form>\r\r";
									
									$fill_forms += "";
									
									// display the passthru field at the top of the page, because those tags are likely to appear inside HTML tags
									// this also emphasizes their global scope
									$output = $output.replace(/(<body[^>]*>)/i, "$1"+$fill_forms);
					
									eval("$isset = (typeof($" + $this_embed + ") != 'undefined')");
									if ($isset) {
										eval("$isfilled = ($" + $this_embed + ".join(\",\") != \"\")");
										if (($this_embed != "")&&($isfilled)) {
											eval('$this_embed_flattened = $' + $this_embed + '.join(",")');
											$this_embed_flattened = $this_embed_flattened.replace(/'/g, "\\'"); // in case the definition contains an apostrophe, which would break the JavaScript array setup code if not escaped
											$stored_selections += "document.contemplate_" + $this_embed + ".embed_value.value = '" + $this_embed_flattened + "';\r\t\t\t\t\t\t\t";				
										}
									}
				
								}
								
								$tag_names.push($this_embed); // keep a list of all the embed tags we processed
							
							}
						
						}
		
					}
					
				}
		
		
			// open the content file, which we can assume to be the second argument
			
				if (($this_type == "file")||($this_type.indexOf("field") != -1)||($this_type.indexOf("random") != -1)||($this_type.indexOf("form") != -1)||($this_type.indexOf("menu") != -1)) {
					eval('$content_file = $' + $this_embed + '[1]');
					$content_file = relative_path($content_file, "content");
					if ($content_file.toLowerCase().indexOf("not authorized") == -1) {
						$content = get_file($content_file, "auto", 1);
					} else {
						$content = $content_file;
						$this_type = "error";
					}
					if ($file_missing) { $this_type = "error"; }
				}
		
		
			// get the desired piece of content...
			
			// ...for file
		
				if ($this_type == "file") {
					// (no parsing necessary here)
				}
				
				
			// ...for field
				
				else if ($this_type.indexOf("field") != -1) {
					eval('$file_type = $' + $this_embed + '[1]'); // determines whether we parse as HTML or XML
					eval('$content_field = $' + $this_embed + '[2]');
					$content = get_field($content, $content_field, $file_type);
				}
			   
			   
			// ...for random
		
				else if ($this_type.indexOf("rand") != -1) {
					eval('$file_type = $' + $this_embed + '[1]'); // determines whether we parse as HTML or XML
					$content_fields = get_field_names($content, $file_type);
					$last_field_index = $content_fields.length - 1;
					
					$content_field = $content_fields[Math.round(Math.random() * $last_field_index)];
					$content = get_field($content, $content_field, $file_type);       		
				}
				
		
			// ...for form
		
				else if ($this_type.indexOf("form") != -1) {
					eval('$file_type = $' + $this_embed + '[1]'); // determines whether we parse as HTML or XML
					eval('$content_field = $' + $this_embed + '[2]');
					eval('$form_element = $' + $this_embed + '[3]');
					$content = get_field($content, $content_field, $file_type);       		
					$content = get_form($content, $form_element);
				}
		
		
			// ...for search
		
				else if ($this_type.indexOf("search") != -1) {
					$search_string = (Request.QueryString("search_string") != $undefined) ? String(Request.QueryString("search_string")) : "" ;
					$search_files = (Request.QueryString("search_files") != $undefined) ? String(Request.QueryString("search_files")) : "" ;
					
					// skip if no search string entered
					if ($search_string != "") {
					
						// if we haven't already loaded the page definitions file, do that now
						if (! $page_definitions) { $page_definitions = get_file($read_page_definitions_from[0], "filesystem", 1); }
					
						// loop through each content file
						$results = new ActiveXObject("Scripting.Dictionary"); // creates an associative array
						$frequency_largest = 0; // this is used by the JScript sorting hack
						$content_files = get_recursive_listing("../content", $read_files_recursively, $search_files);
						$content_files_count = $content_files.length;
						for ($j=0; $j<$content_files_count; $j++) {
							$file_name = $content_files[$j];
							$file_text = get_file(relative_path($file_name, "content"), "filesystem", 0);
							//$output += "Searching file " + relative_path($file_name, "content") + "<p>\r\r"; // debug
			
							// if the file contains the search string...
							$re = new RegExp('(.*?)(' + $search_string + ')(.*)', 'i'); // we'd like to use the s flag here, if it existed in ASP
							if ($re.test($file_text)) {
			
								// ...create a preview of the found text...
								$results_preview = make_preview(RegExp.$1, RegExp.$2, RegExp.$3);
								
								// ...and count how many times it appears in the file
								$frequency_file = 0;
							
								// then get the field names in the file, and loop through each field
								$content_fields = get_field_names($file_text, $file_name);
								$content_fields_count = $content_fields.length;
								for ($k=0; $k<$content_fields_count; $k++) {
									$field_name = $content_fields[$k];
									$field_text = get_field($file_text, $field_name, $file_name);
									$field_name = $content_fields[$k]; // we need to reinstate $field_name, which get_field() inadvertently changes
								
									// if the field contains the search string...
									$field_text = strip_tags($field_text); // exclude text contained in a tag
									$re = new RegExp('(.*?)(' + $search_string + ')(.*)', 'i'); // we'd like to use the s flag here, if it existed in ASP
									if ($re.test($field_text)) {
										
										// ...create a preview of the found text...
										$results_preview = make_preview(RegExp.$1, RegExp.$2, RegExp.$3);
										
										// ...and count how many times it appears in the field
										$frequency_field = 0;
										while ($field_text.toLowerCase().indexOf($search_string) != -1) {
											$frequency_field++;
											$frequency_file++;
											if ($frequency_file > $frequency_largest) { $frequency_largest = $frequency_file; }
											if ($frequency_field > $frequency_largest) { $frequency_largest = $frequency_field; }
											$re = new RegExp($search_string, 'i');
											$field_text = $field_text.replace($re, "");
										}
			
										// look up the relevant page names, then add the preview and frequency to our results array
										$found_args = "field," + $file_name + "," + $field_name;
										$pages = get_page_names_containing($found_args, $page_definitions);
										$pages_count = $pages.length;
										for ($l=0; $l<$pages_count; $l++) {
											$results.Add($pages[$l] + " : " + $results_preview, $frequency_field);
										}
										
									}
								
								}
								
								// look up the relevant page names, then add the preview and frequency to our results array
								$found_args = "file," + $file_name;
								$pages = get_page_names_containing($found_args, $page_definitions);
								$pages_count = $pages.length;
								for ($l=0; $l<$pages_count; $l++) {
									$results.Add($pages[$l] + " : " + $results_preview, $frequency_file);
								}
								
							}
							
						}
						
						// rank the search results by frequency
						$results_keys = (new VBArray($results.Keys())).toArray();
						$results_values = (new VBArray($results.Items())).toArray();
		
						// JScript can't sort associative arrays, so we have to flatten this into a regular array with the frequency first, sort that, then split it up again
						$results_flattened = new Array();
						$frequency_largest = String($frequency_largest);
						for ($r=0; $r<$results.Count; $r++) {
							$this_key = String($results_keys[$r]);
							$this_value = String($results_values[$r]);
							// add leading zeroes to the value so we can sort it alphabetically
							while ($this_value.length < $frequency_largest.length) { $this_value = "0" + $this_value; }
							$this_pair = $this_value + " :: " + $this_key;
							$results_flattened.push($this_pair);
						}
						function sort_descending (a,b) { return ( (a>b) ? -1 : ( (a<b) ? 1 : 0 ) ) }
						$results_flattened.sort(sort_descending); // unfortunately, this sorts by frequency in descending order, then by name also in descending order; so items of the same frequency will appear in reverse order
						$results_keys = new Array();
						$results_values = new Array();
						for ($r=0; $r<$results_flattened.length; $r++) {
							$this_pair = $results_flattened[$r].split(" :: ");
							$this_key = $this_pair[1];
							$this_value = $this_pair[0];
							// remove leading zeroes from the value so we can display it numerically
							while (($this_value.length > 1) && ($this_value.substr(0, 1) == "0")) { $this_value = $this_value.substr(1, $this_value.length); }
							$results_keys.push($this_key);
							$results_values.push($this_value);
						}
		
						//$content = "<table cellspacing=8 cellpadding=0 border=0>\r";  // these lines provide a different display option
						$content = "";
						$keys_count = $results_keys.length;
						for ($j=0; $j < $keys_count; $j++) {
							$this_page = $results_keys[$j].substr(0, $results_keys[$j].indexOf(" : "));
							$this_preview = $results_keys[$j].substr($results_keys[$j].indexOf(" : ") + 3);
							$this_frequency = $results_values[$j];
							//$content += "<tr valign=top>\r<td class=body>" + $this_frequency + "</td>\r";
							//$content += "<td class=body><a href=../contemplate/assembler.asp?page=" + $this_page + ">contemplate/assembler.asp?page=" + $this_page + "</a><br>\r<img src=../contemplate/graphics/spacer.gif width=1 height=4 alt=''><br>\r" + $this_preview + "\r</td>\r</tr>";
							if ($URL_rewriting_flag) {
								$content += "<p class=\"search-results-preview\"><a href=\"../" + $URL_rewriting_flag + "/" + $this_page + ".html\" class=\"search-results-link\">" + $URL_rewriting_flag + "/" + $this_page + ".html</a><br>\r<img \"src=../contemplate/graphics/spacer.gif\" width=\"1\" height=\"4\" alt=\"\"><br>\r" + $this_preview + " (" + $this_frequency + ")</p>\r\r";
							} else {
								$content += "<p class=\"search-results-preview\"><a href=\"../contemplate/assembler.asp?page=" + $this_page + "\" class=\"search-results-link\">contemplate/assembler.asp?page=" + $this_page + "</a><br>\r<img \"src=../contemplate/graphics/spacer.gif\" width=\"1\" height=\"4\" alt=\"\"><br>\r" + $this_preview + " (" + $this_frequency + ")</p>\r\r";
							}
						}
						//$content += "</table>\r";
						
						if ($content) {
							$content = "<p class=\"search-results-heading\">" + $search_label_success + " \"" + $search_string + "\":</p>" + $content;
						} else {
							$content = "<p class=\"search-results-heading\">" + $search_label_failure + " \"" + $search_string + "\"</p>";
						}
					} else {
						$content = "<p class=\"search-results-heading\">" + $search_label_none + "</p>";
					}
				}
		
		
			// ...for menu
			
				else if ($this_type.indexOf("menu") != -1) {
					eval('$file_type = $' + $this_embed + '[1]'); // determines whether we parse as HTML or XML
					eval('$content_field = $' + $this_embed + '[2]');
					eval('$data_type = $' + $this_embed + '[3]'); // text, graphics, or links
					$content = get_field($content, $content_field, $file_type);

					if ($data_type == "graphics") { $data_type = "images"; } // this gives backwards compatibility from versions 1.1.0 to 1.2.2
					
					if (String($content).indexOf("Assembler error") == -1) {
	
						if ($data_type != "html") { // for this type, we'll just return the complete content
					
							// strip out unnecessary tags and spaces to make this easier to parse
							$content = $content.replace(/<\/li>/gi, "");
							$content = $content.replace(/\r/g, "");
							$content = $content.replace(/\s\s/g, " ");
							
							// first, find and number all lists and items
							$levels = new Array();
							$greatest = 0;
							$limit = 0; // this is to prevent runaways while developing; we can delete it later
							while (($content.search(/<\/ul\D/i) != -1)&&($limit < 100)) { // we'd like to use the s flag here, if it existed in ASP
								// which is next, a list item or a new child list?
								$re = new RegExp("<li\\D(.*)", "i"); // we'd like to use the s flag here, if it existed in ASP
								if ($re.test($content)) { $length_after_item = RegExp.$1.length; } else { $length_after_item = -1; }
								$re = new RegExp("<ul\\D(.*)", "i"); // we'd like to use the s flag here, if it existed in ASP
								if ($re.test($content)) { $length_after_list = RegExp.$1.length; } else { $length_after_list = -1; }
								$re = new RegExp("<\/ul\\D(.*)", "i"); // we'd like to use the s flag here, if it existed in ASP
								if ($re.test($content)) { $length_after_end_list = RegExp.$1.length; } else { $length_after_end_list = -1; }
								if (($length_after_list > $length_after_item)&&($length_after_list > $length_after_end_list)) {
									$greatest++;
									$levels.push($greatest);
									$content = $content.replace(/<ul(\D)/i, "<ul" + $greatest + "$1");
									//$output += "<br>adding list " + $greatest;  // debug
								} else if (($length_after_item > $length_after_list)&&($length_after_item > $length_after_end_list)) {
									$next = $levels[$levels.length - 1];
									$content = $content.replace(/<li(\D)/i, "<li" + $next + "$1");
									//$output += "<br>adding item " + $next;  // debug
								} else {
									$next = $levels.pop();
									$content = $content.replace(/<\/ul(\D)/i, "</ul" + $next + "$1");
									//$output += "<br>adding end list " + $next;  // debug
								}
								$limit++;
							}
							
							// then work through each list from deepest to shallowest and create a string formatted like an array
							$child_lists = Array();
							$child_lists[0] = ""; // we won't use the 0 index, but pad it now for consistency across languages
							for ($j=$greatest; $j>0; $j--) {
								$re = new RegExp("<ul" + $j + "[^>]*>(.*)<\/ul" + $j + ">", "i"); // we'd like to use the s flag here, if it existed in ASP
								if ($re.test($content)) {
									$child_lists[$j] = RegExp.$1;
									$re2 = new RegExp("<ul" + $j + "[^>]*>.*<\/ul" + $j + ">", "i"); // we'd like to use the s flag here, if it existed in ASP
									$content = $content.replace($re2, "-child-list-" + $j + "-");
									$child_lists[$j] = $child_lists[$j].split(/<li[^>]*>/);
									for ($k=1; $k<$child_lists[$j].length; $k++) {
										//$output += "processing list " + $j + " item " + $k + "<br>"; // debug
										$re2 = new RegExp("-child-list-(\\d+)-", "");
										if ($re2.test($child_lists[$j][$k])) {
											$replace_index = RegExp.$1;
											$child_lists[$j][$k] = $child_lists[$j][$k].replace("-child-list-" + $replace_index + "-", "");
										} else {
											$replace_index = 0;
										}
										if ($data_type == "text") {
											$child_lists[$j][$k] = strip_tags($child_lists[$j][$k]);
											$child_lists[$j][$k] = $child_lists[$j][$k].replace(/([\[\]\'\"])/g, "\\$1"); // escape characters that would break the array output
										}
										if ($data_type == "images") {
											$child_lists[$j][$k] = $child_lists[$j][$k].replace("src", "s-r-c"); // why in the world is this step necessary?
											$re2 = new RegExp("s-r-c\\s*=\\s*[\"\']?([^\"\'\\s>]+)[\"\'\\s>]", "i");
											if ($re2.test($child_lists[$j][$k])) {
												$child_lists[$j][$k] = RegExp.$1;
											} else {
												$child_lists[$j][$k] = "";
											}
										}
										if ($data_type == "images_width") {
											$child_lists[$j][$k] = $child_lists[$j][$k].replace("width", "w-i-d-t-h"); // why in the world is this step necessary?
											$re2 = new RegExp("w-i-d-t-h\\s*=\\s*[\"\']?([^\"\'\\s>]+)[\"\'\\s>]", "i");
											if ($re2.test($child_lists[$j][$k])) {
												$child_lists[$j][$k] = RegExp.$1;
											} else {
												$child_lists[$j][$k] = "";
											}
										}
										if ($data_type == "images_height") {
											$child_lists[$j][$k] = $child_lists[$j][$k].replace("height", "h-e-i-g-h-t"); // why in the world is this step necessary?
											$re2 = new RegExp("h-e-i-g-h-t\\s*=\\s*[\"\']?([^\"\'\\s>]+)[\"\'\\s>]", "i");
											if ($re2.test($child_lists[$j][$k])) {
												$child_lists[$j][$k] = RegExp.$1;
											} else {
												$child_lists[$j][$k] = "";
											}
										}
										if ($data_type == "images_alt") {
											$child_lists[$j][$k] = $child_lists[$j][$k].replace("alt", "a-l-t"); // why in the world is this step necessary?
											$re2 = new RegExp("a-l-t\\s*=\\s*[\"\']?([^\">]+)[\">]", "i");
											if ($re2.test($child_lists[$j][$k])) {
												$child_lists[$j][$k] = RegExp.$1;
												$child_lists[$j][$k] = $child_lists[$j][$k].replace(/([^\\])'/, "$1\\'"); // escape any apostrophes in the alt text (unless they are already escaped)
											} else {
												$child_lists[$j][$k] = "";
											}
										}
										if (($data_type == "links")||($data_type == "active")) {
											$child_lists[$j][$k] = $child_lists[$j][$k].replace("href", "h-r-e-f"); // why in the world is this step necessary?
											$re2 = new RegExp("h-r-e-f\\s*=\\s*[\"\']?([^\"\'\\s>]+)[\"\'\\s>]", "i");
											if ($re2.test($child_lists[$j][$k])) {
												$child_lists[$j][$k] = RegExp.$1;
											} else {
												$child_lists[$j][$k] = "";
											}
										}
										$child_lists[$j][$k] = "'" + $child_lists[$j][$k].replace(/^\s*(.*)\s*$/, "$1") + "'"; // no trim function?
										if ($replace_index) {
											$child_lists[$j][$k] = $child_lists[$replace_index].replace("[", "[" + $child_lists[$j][$k] + ", ");
										}
									}
									$child_lists[$j].shift(); // the first element, anything before the first <li>, is junk, so throw it away
									$child_lists[$j] = "[" + $child_lists[$j].join(", ") + "]";
								}
							}
							if ($child_lists.length > 1) {
								$content = $child_lists[1];
							} else {
								$content = "[]";
							}
							
							// if the data type is active, loop through the links array and find the active link (it would be nicer to catch this as we build the arrays, but at that point we don't know what position the active element will eventually hold in the multidimensional array)
							if ($data_type == "active") {
								$links = $content;
								eval('$links = ' + $links + ';');
								$array_path = "";
								$re = new RegExp("\\b" + $page + "\\b", "i");
								for ($j=0; $j<$links.length; $j++) {
									if (typeof($links[$j]) != "string") {
										$element_flattened = $links[$j].join(",");
									} else {
										$element_flattened = $links[$j];
									}
									//$output += "checking element " + $j + " of " + $links.length + ": " + $element_flattened + "<br>"; // debug
									if ($re.test($element_flattened)) {
										//$output += "element " + $j + " is a match<br>"; // debug
										$array_path += $j;
										if ($element_flattened.indexOf(",") != -1) {
											$array_path += ",";
											$links = $links[$j];
											$j = 0;
										} else {
											break; // we found it!
										}
									}
								}
								$content = "[" + $array_path + "]";
							}
							
						}

					}
				}
		
		
			// ...for navigation
			
				else if (($this_type.indexOf("nav_current") != -1)||($this_type.indexOf("nav_total") != -1)||($this_type.indexOf("nav_next") != -1)||($this_type.indexOf("nav_prev") != -1)||($this_type.indexOf("nav_first") != -1)||($this_type.indexOf("nav_last") != -1)) {
					$content = process_tag_nav($this_type);						
				}
		
		
			// ...for environment variable
			
				else if ($this_type.indexOf("env_") != -1) {
					$content = process_tag_env($this_type);
										
					// uncomment this to see all available variables
					//while(list($key,$val)=each($_SERVER)) { // debug
					//	$output += $key + " = " + $val + "<br>";
					//}
				}
		
		
			// ...for passthrough/passthru
			
				else if ($this_type.indexOf("passthr") != -1) {
					// these variables don't exist internally as arrays; this fakes it so they're still available in passthru tags
					if (($this_embed == "page")||($this_embed == "template")||($this_embed == "page_definition")) {
						if (($split_page_names_on != "")&&($this_embed == "page")) {
							if ($this_embed_passthru_index == "") {
								// if no index is specified, return the whole page name
								$content = $page;
							} else {
								$page_array = $page.split($split_page_names_on);
								if ($page_array.length > $this_embed_passthru_index) {
									eval('$content = $page_array[' + $this_embed_passthru_index + ']');
								} else {
									$content = "";
								}
							}
						} else {
							eval('$content = $' + $this_embed);
						}
					} else {
						eval("$isset = (typeof($" + $this_embed + ") != 'undefined')");
						if ($isset) {
							if ($this_embed_passthru_index == "") {
								// if no index is specified, return the whole array as a string
								eval('$content = $' + $this_embed + '.join(",")');
							} else {
								eval('$islength = ($' + $this_embed + '.length) > $this_embed_passthru_index');
								if ($islength) {
									eval('$content = $' + $this_embed + '[' + $this_embed_passthru_index + ']');
								} else {
									$content = "";
								}
							}
						} else {
							$content = "";
						}
					}
				}
		
		
			// ...or for nothing!
				
				else if ($this_type.indexOf("skip") != -1) {
					$content = "<!-- Embed tag \"" + $this_embed + "\" not parsed because of blank or too few arguments in URL -->";
				}
		
				else if ($this_type.indexOf("ignore") != -1) {
					// do nothing at all
				}
		
				else if ($this_type.indexOf("error") == -1) {
					$content = show_error("Can't understand the data type \"" + $this_type + "\"<br>Available types: file, field, random, form, search, nav_current, nav_total, nav_next, nav_previous, nav_first, nav_last, env_*, or passthru" + $check_embed);
				}
				
				
			// skip the rest of the parsing if this tag generated an error
			
				if (String($content).indexOf("Assembler error") == -1) {
				
				
				// remove all markup from the embed content if the strip attribute was included in the embed tag
				
					if ($this_embed_strip) {
						$content = strip_tags($content);
					}
				   
				   
				// do some search-and-replaces if the replace attribute was included in the embed tag
				
					if ($this_embed_replace) {
						$replace_count = $this_embed_replace.length / 2;
						for ($j=0; $j < $replace_count; $j++) {
							$search = $this_embed_replace[$j*2];
							$replace = $this_embed_replace[($j*2)+1];
							$re = new RegExp($search, 'g');
							$content = $content.replace($re, $replace);
						}
					}
				   
			
				}
				
						
			// add the new content to the output...
			
				if (! $this_embed_variable) {
		
					// replace all instances normally, but only the first instance in the formulator
					if (!$formulator_fill) {
						$re = new RegExp('-embed-' + $i + '-', 'g');
						$output = $output.replace($re, $content);
					} else {
						$re = new RegExp('-embed-' + $i + '-', '');
						$output = $output.replace($re, $content);
						// delete the extra embed placeholders that we didn't use in the formulator
						$re = new RegExp('-embed-' + $i + '-', 'g');
						$output = $output.replace($re, "");
					}
				
				} else {
				
		
			// ...or just save it as a variable and delete the embed placeholder
		
					$embed_variable_keys[$embed_variable_keys.length] = $this_embed;
					$embed_variable_values[$embed_variable_values.length] = $content;
		
					$re = new RegExp('-embed-' + $i + '-', 'g');
					$output = $output.replace($re, "");
		
				}
				
		
			// finally, start over with the next embed
			
				$last_content = $content;
				$content = "";
				$i++;
			
			}
	
		}
	

// add formulator data to the bottom of the document (we can't do this until we're done with recursive parsing)

	if ($formulator_fill) {
	
		if ($tag_names.length) { // don't bother with all this processing if there are no fillable tags
		
			$content_folder_only = 1; // we'll tell JavaScript whether we're using any nonstandard file locations
			$content_files = new Array();
			for ($j=0; $j<$read_files_from.length; $j++) {
				$this_directory = $read_files_from[$j];
				if (($this_directory.indexOf("../contemplate") == -1)&&($this_directory.indexOf("../templates") == -1)) {
					if ($this_directory.indexOf("../content") == -1) { $content_folder_only = 0; }
					$this_files = get_recursive_listing($this_directory, $read_files_recursively, "");
					for ($k=0; $k<$this_files.length; $k++) {
						$this_file = $this_files[$k];
						$content_files.push($this_directory + $this_file);
					}
				}
			}
			$file_fields = "";
			$field_forms = "";
			
			// build an array of fields for each content file...
			for ($j=0; $j<$content_files.length; $j++) {
				$this_file_name = $content_files[$j];
				$this_file_nopunctuation = $this_file_name;
				$this_file_nopunctuation = $this_file_nopunctuation.replace(/\./g, "_");
				$this_file_nopunctuation = $this_file_nopunctuation.replace(/\//g, "_");
				$this_file_nopunctuation = $this_file_nopunctuation.replace(/-/g, "_");
				$this_file_nopunctuation = $this_file_nopunctuation.replace(/ /g, "_");
				$this_file_nopunctuation = $this_file_nopunctuation.replace(/^_*(.*)_*$/g, "$1");
				$this_file_text = get_file($this_file_name, "filesystem", 0);
				$this_file_fields = get_field_names($this_file_text, $this_file_name);
				if ($this_file_fields.length) {
					$this_file_fields = $this_file_fields.join("', '");
					$file_fields += "parent." + $this_file_nopunctuation + "_fields = Array('" + $this_file_fields + "'); // file " + $j + "\r\t\t\t\t\t\t\t";
				}
				
				// ...and an array of forms for each field
				if ($this_file_fields.length) { $this_file_fields = $this_file_fields.split("', '"); }
				for ($k=0; $k<$this_file_fields.length; $k++) {
					$this_field_name = $this_file_fields[$k];
					$this_field_nopunctuation = $this_field_name;
					$this_field_nopunctuation = $this_field_nopunctuation.replace(/\./g, "_");
					$this_field_nopunctuation = $this_field_nopunctuation.replace(/\//g, "_");
					$this_field_nopunctuation = $this_field_nopunctuation.replace(/-/g, "_");
					$this_field_nopunctuation = $this_field_nopunctuation.replace(/ /g, "_");
					$this_field_nopunctuation = $this_field_nopunctuation.replace(/^_*(.*)_*$/g, "$1");
					$content_file = $this_file_name; // ASP insists on this variable being available when get_field runs
					$this_field_text = get_field($this_file_text, $this_field_name, $this_file_name);
					$this_field_forms = get_form_names($this_field_text);
					if ($this_field_forms.length) {
						$this_field_forms = $this_field_forms.join("', '");
						$field_forms += "parent." + $this_file_nopunctuation + "_" + $this_field_nopunctuation + "_forms = Array('" + $this_field_forms + "'); // form " + $j + ":" + $k + "\r\t\t\t\t\t\t\t";
					}
				}
			}
			
			$tag_names_javascript = $tag_names.join("', '");
			$content_files_javascript = $content_files.join("', '");
	
			$fill_data = "";
			
			$fill_data += "	<script language=JavaScript>\r\r";
			
			$fill_data += "		function load_menu(menu_name, menu_title, values) {\r";
			$fill_data += "			clear_menu(menu_name, menu_title);\r";
			$fill_data += "			menu_name.options[0] = new Option(menu_title, '0');\r";
			$fill_data += "			if (values.length) {\r";
			$fill_data += "				for (i=0; i < values.length; i++) {\r";
			$fill_data += "					this_value = values[i];\r";
			$fill_data += "					if (menu_title == 'File...') {\r";
			$fill_data += "						if (parent.content_folder_only) {\r";
			$fill_data += "							// remove the '../content/' if all the files are in that folder\r";
			$fill_data += "							this_value_display = this_value.substring(11, this_value.length);\r";
			$fill_data += "						} else {\r";
			$fill_data += "							// just remove the '../' otherwise\r";
			$fill_data += "							this_value_display = this_value.substring(3, this_value.length);\r";
			$fill_data += "						}\r";
			$fill_data += "					} else {\r";
			$fill_data += "						this_value_display = this_value;\r";
			$fill_data += "					}\r";
			$fill_data += "					menu_name.options[i+1] = new Option(this_value_display, this_value);\r";
			$fill_data += "				}\r";
			$fill_data += "			} else {\r";
			$fill_data += "				menu_name.options[1] = new Option('(none available)', '0');\r";
			$fill_data += "			}\r";
			$fill_data += "		}\r\r";
			
			$fill_data += "		function clear_menu(menu_name, menu_title) {\r";
			$fill_data += "			menu_name.options[0] = new Option(menu_title, '0');\r";
			$fill_data += "			for (i=menu_name.options.length; i > 1; i--) {\r";
			$fill_data += "				menu_name.options[i-1] = null;\r";
			$fill_data += "			}\r";
			$fill_data += "		}\r";
	
			$fill_data += "		parent.tag_types = Array('file', 'field', 'form', 'random', 'none');\r\r";
			$fill_data += "		parent.tag_names = ('" + $tag_names_javascript + "') ? Array('" + $tag_names_javascript + "') : Array() ;\r\r";
			$fill_data += "		parent.content_files = ('" + $content_files_javascript + "') ? Array('" + $content_files_javascript + "') : Array() ;\r\r";
					
			$fill_data += "		parent.content_folder_only = " + $content_folder_only + ";\r\r";
					
			$fill_data += "		" + $file_fields + "\r\r";
					
			$fill_data += "		" + $field_forms + "\r\r";
					
			$fill_data += "		" + $stored_selections + "\r\r";
			
			$fill_data += "		parent.contemplate_toolbar.location = 'formulator/toolbar.html?step=4'; // the formulator waits for this code to reload the toolbar\r\r";

			$fill_data += "	</script>\r\r";
				
		} else {
		
			// if there are no fillable tags, advance the formulator toolbar to the next step
			$fill_data = "";
			
			$fill_data += "<script language=JavaScript>\r";
			$fill_data += "		parent.tag_names = Array();\r";
			$fill_data += "		parent.contemplate_toolbar.location = 'formulator/toolbar.html?step=5'; // the formulator waits for this code to reload the toolbar\r";
			$fill_data += "	</script>\r";
			
		}
		
		$output = $output.replace(/<\/html>/i, $fill_data + "</html>"); // insert the JavaScript at the end of the file // we'd like to use the s flag here, if it existed in ASP
	
	}
	

// merge argument values back together, since other scripts won't expect them to be arrays
	
		for ($i=0; $i<$args_count; $i++) {
			$pair = $args[$i].split("=");
			$key = $pair[0];
			if ((","+$settings_used+",").indexOf(","+$key+",") == -1) {
				$value = ($pair.length > 1) ? $pair[1] : "" ;
				eval('$' + $key + ' = $value');
			}
		}
	
	
// put content into any embed tag names marked with the variable attribute (we do this after merging argument variables in case they have the same names)
	
		for ($i=0; $i<$embed_variable_keys.length; $i++) {
			eval($embed_variable_keys[$i] + ' = $embed_variable_values[$i]'); // ASP variables don't start with $ like the other languages
		}
	
	
// set external link targets if requested in prefs file
	
		if ($external_link_target) {
			// temporarily remove server-side script tags that might confuse this parsing
			$re = new RegExp("<" + "%(.*?)%" + ">", "g");
			$output = $output.replace($re, "script_tag_start_!@#$1script_tag_end_!@#");
			// add our default target to every anchor tag
			$output = $output.replace(/<a href=([\'\"]?\w+:\/\/[^>]*)>/g, "<a href=$1 target=" + $external_link_target + ">");
			// then remove it from every tag that already had one
			$output = $output.replace(/<a href=([\'\"]?\w+:\/\/[^>]*target=[^>]*) target=[^>]*>/g, "<a href=$1>");
			// restore server-side script tags
			$output = $output.replace(/script_tag_start_!@#(.*?)script_tag_end_!@#/g, "<" + "%$1%" + ">");
		}


	} // end of the "if $page_definition" check


// return the parsed text as an HTML file

	$header_array = $header.split("\r");
	for ($i=0; $i<$header_array.length; $i++) {
		$this_header = $header_array[$i].split(": ");
		$this_header_name = $this_header[0];
		$this_header_value = $this_header[1];
		if ($this_header_name != "") {
			Response.AddHeader($this_header_name, $this_header_value);
		}
	}
		
	// prepare to evaluate the output as ASP, unless the flattener tells us to skip it, or unless we see that there are no scripts in the assembled page
	
	// this assumes that ASP scripts will start with a tag like <% or <script language="VBScript" runat="Server">
	// this also assumes that all the long-format script tags will include the runat attribute, and that no other script tags will; is that a safe assumption?
	$re1 = new RegExp("(<script[^>]*?language[^>]*?runat[^>]*?\>)(.*?)<\/script\>", "i"); // putting the parens inside the ASP tags make the tags go away in the final output  // we'd like to use the s flag here, if it existed in ASP
	$re2 = new RegExp("<\%(.*?)%\>", "g"); // this is an alternate format for the script tag, which we will interpret as VBScript  // we'd like to use the s flag here, if it existed in ASP
	
	if ( ($skip_rendering) || ( !($re1.test($output)) && !($re2.test($output)) ) ) {
	
		// change to the preferred line ending set in preferences.ini
		// we can't do this for the next section yet because the regexps that we still have to do won't work on multiple lines due to JScript's lack of support for the s flag
		$output = $output.replace(/\r/g, $line_ending);
			
		// if there are no scripts to evaluate, just print the output
		Response.write($output);
		
	} else {
	
		// if we have scripts to evaluate, we'll separate the assembled page into its HTML, ASP/VBScript, and ASP/JScript pieces and process each part separately
		// this lets us support both VBScript and JScript in the same assembled page
		// but we'll save a copy of $output for use in the show_source routine below
		$output_pieces = $output;
		
		// first, expand the = shortcut to Response.write...
		$re3 = new RegExp("<\%\\s*=\\s*", "g");
		$output_pieces = $output_pieces.replace($re3, "<\% Response.write ");
		
		// ...and convert short-format tags to long-format VBScript tags
		$output_pieces = $output_pieces.replace($re2, "<script language=\"VBScript\" runat=\"Server\">$1</script>");

		// then extract all the ASP scripts of either language from the assembled page
		$ASP_pieces = new Array();
		$ASP_pieces_types = new Array();
		$ASP_pieces_count = 0;
		while ($re1.test($output_pieces)) {
			$ASP_pieces[$ASP_pieces_count] = RegExp.$2;
			$ASP_pieces_types[$ASP_pieces_count] = (RegExp.$1.toLowerCase().indexOf("jscript") != -1) ? "JScript" : "VBScript" ;
			$output_pieces = $output_pieces.replace($re1, "-ASP_piece-");
			$ASP_pieces_count++;
		}
	
		// now that we're done with all the regular expressions, we can change to the preferred line ending set in preferences.ini
		$output_pieces = $output_pieces.replace(/\r/g, $line_ending);
		$output = $output.replace(/\r/g, $line_ending);

		// finally, loop through all the pieces, printing HTML pieces, evaluating JScript pieces, and executing VBScript pieces
		$output_pieces = $output_pieces.split("-ASP_piece-");
		Response.write($output_pieces[0]); // output the first piece of HTML (which might be the whole page, if there's no scripting)
		if ($ASP_pieces_count > 0) {
			for ($i=0; $i<$ASP_pieces_count; $i++) {
			
				// output the next piece of ASP
				if ($ASP_pieces_types[$i] == "JScript") {
					eval($ASP_pieces[$i]);
				} else {
					eval_VB($ASP_pieces[$i]);
				}
				
				// output the next piece of HTML, which will eventually be the last piece
				Response.write($output_pieces[$i + 1]);
			}
		}
		
 		// if requested, display the output in a numbered, pre-rendered format so we can see where an error occurred
 		// but only allow this from IP addresses listed in the preferences file
 		$show_source_approved = 0;
		if ($show_source_to) {
			for ($i=0; $i < $show_source_to_count; $i++) {
				if ((Request.ServerVariables("REMOTE_ADDR") != $undefined)&&(String(Request.ServerVariables("REMOTE_ADDR")) == $show_source_to[$i])) { $show_source_approved = 1; }
			}
		}
		if (($show_source)&&($show_source_approved)) {
 			$output_numbered = $output;
			$output_numbered = $output_numbered.replace(/</g, "&lt;");
			$output_numbered = $output_numbered.replace(/>/g, "&gt;");
 			$output_numbered = $output_numbered.split($line_ending);
 			for ($i=0; $i<$output_numbered.length; $i++) {
 				$output_numbered[$i] = "<tr valign=top><td><font face=geneva,verdana,sans-serif color=#999999>" + ($i+1) + "</font></td><td>&nbsp;</td><td><font face=geneva,verdana,sans-serif>" + $output_numbered[$i] + "</font></td></tr>";
 			}
 			$output_numbered = $output_numbered.join($line_ending);
			Response.write("<html>\r<body bgcolor=#FFFFFF>\r<p>\r<table>\r" + $output_numbered + "\r</table>\r</p>\r</body>\r</html>\r");
		}

	}


// log this hit in the traffic reports

	if (($log_traffic)&&(!$formulator_fill)) {
	
		 $status = (Request.ServerVariables("REDIRECT_STATUS") != $undefined) ? String(Request.ServerVariables("REDIRECT_STATUS")) : "" ;

		if (($request.indexOf("assembler.asp") != -1)||($URL_rewriting_flag)||($status == "200")) {
			// if we recognize the request as a call to the assembler, display either the page name or the expanded URL
			if (!$page) { $page = $page_definition; }
		} else {
		 	// ... otherwise, we must have been redirected to here, so show the original request with the error code
		 	$page = $request.substr(1); // the substr removes the initial slash
		 	$error_log = ($status) ? $status : "Unknown" ;
		}
		
		// catch the other environment variables now
		$IP_address = (Request.ServerVariables("REMOTE_ADDR") != $undefined) ? String(Request.ServerVariables("REMOTE_ADDR")) : "" ;
		$host = (Request.ServerVariables("REMOTE_HOST") != $undefined) ? String(Request.ServerVariables("REMOTE_HOST")) : $IP_address ; // if we knew that all servers substituted the IP address for us when the host is missing, then we could remove the conditional here
		$user_agent = (Request.ServerVariables("HTTP_USER_AGENT") != $undefined) ? String(Request.ServerVariables("HTTP_USER_AGENT")) : "" ;
		$referrer = (Request.ServerVariables("HTTP_REFERER") != $undefined) ? String(Request.ServerVariables("HTTP_REFERER")) : "" ;
		
		// find out whether we need to do our own host lookup
		if ($host_lookups == "auto") {
			$host_lookups = ($host == $IP_address) ? "on" : "off" ;
		}
		if ($host_lookups == "on") {
		
			// NOTE: this section requires Windows NT (Server or Workstation) or Windows 2000 (Server or Professional) and Windows Script Host 2.0
			// if your server doesn't meet these requirements, you can set "host lookups for logs" to "off" in your data/preferences.ini file to avoid script errors
		
			// create shell and FSO objects
			ShellObject = ""; ShellObject = Server.CreateObject("Wscript.Shell");
			FSO = ""; FSO = Server.CreateObject("Scripting.FileSystemObject");
		
			if ((ShellObject)&&(FSO)) {
				// run NSLookup via the CLI and save results into a temp text file
				ShellObject.Run("%ComSpec% /c nslookup " + $IP_address + "> C:\\NSLookup_" + $IP_address + ".txt", 0, 1);

				// open the temp text file and read out the data
				$temp_file = FSO.OpenTextFile("C:\\NSLookup_" + $IP_address + ".txt");
				$lookup_text = $temp_file.ReadAll();
			
				// close and delete the temp file
				$temp_file.Close();
				FSO.DeleteFile("C:\\NSLookup_" + $IP_address + ".txt");
			}
			
			// parse the host name out of the lookup results
			$re = new RegExp("Name:\s*([^\r\n]*)", "");
			if ($re.test($lookup_text)) { $host = RegExp.$1; }
		
			// delete the object instances
			FSO = "";
			ShellObject = "";
			
		}

		// add the visitor ID to each entry if we're using cookies to track visitors
		if ($track_visitors) {
			if ($visitor_ID == "") {
				// get the visitor ID from the cookie if we didn't just generate one on this page
				// if we ever use the cookie to store other data, we can move this code to the top the script so that it's available to the rest of the script; right now it's here so that we can only run it when we need it
				$cookie_data = new Array();
				$cookie_data_raw = String(Request.Cookies("Contemplate"));
				$cookie_data_raw = $cookie_data_raw.split("&");
				for ($i=0; $i<$cookie_data_raw.length; $i++) {
					$cookie_data_item = $cookie_data_raw[$i].split("=");
					$cookie_data[$cookie_data_item[0]] = $cookie_data_item[1];
				}
				$visitor_ID = $cookie_data["visitor_ID"];
			}
			$visitor_ID_with_tab = $visitor_ID + "\t";
		} else {
			$visitor_ID_with_tab = "";
		}
		
		$SQL_timestamp_split = $SQL_timestamp.split("-");
		$year = $SQL_timestamp_split[0];
		$month = $SQL_timestamp_split[1];
		$traffic_file = absolute_path("data/reporter/" + $year + "-" + $month + ".txt", "filesystem");
		$error_file = absolute_path("data/reporter/" + $year + "-" + $month + "-errors.txt", "filesystem");
				
		if (!$error_log) {
			FSO = Server.CreateObject("Scripting.FileSystemObject");
			$my_file = FSO.OpenTextFile($traffic_file, 8, 1); // 8 means append, 1 means create if necessary
			if ((! FSO)||(! $my_file)) {
				$output_two += "<!-- Can't open the traffic data file $traffic_file -->\r";
			} else {
				$log_line = $SQL_timestamp + "\t" + $visitor_ID_with_tab + $IP_address + "\t" + $host + "\t" + $page + "\t" + $user_agent + "\t" + $referrer; // in ASP, we don't include a line break at the end
				$my_file.WriteLine($log_line);
				$my_file = "";
				FSO = "";
			}
		} else {
			FSO = Server.CreateObject("Scripting.FileSystemObject");
			$my_file = FSO.OpenTextFile($error_file, 8, 1); // 8 means append, 1 means create if necessary
			if ((! FSO)||(! $my_file)) {
				$output_two += "<!-- Can't open the error file $error_file -->\r";
			} else {
				$log_line = $SQL_timestamp + "\t" + $visitor_ID_with_tab + $IP_address + "\t" + $host + "\t" + $page + "\t" + $user_agent + "\t" + $referrer + "\t" + $error_log; // in ASP, we don't include a line break at the end
				$my_file.WriteLine($log_line);
				$my_file = "";
				FSO = "";
			}
		}
		
	}
	
%>